#ifndef _H_95F24B6507C8E318327A1432EDE96D3E_GridMap__H_
#define _H_95F24B6507C8E318327A1432EDE96D3E_GridMap__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"
#include "sensor_msgs/msg/dds_opensplice/Image_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  GridMap_
            {
                struct _map_names__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _map_names__seq_uniq_ > _map_names__seq;
                typedef DDS_DCPSUStrSeq_var< _map_names__seq > _map_names__seq_var;
                typedef DDS_DCPSUStrSeq_out< _map_names__seq > _map_names__seq_out;
                struct _map_data__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::sensor_msgs::msg::dds_::Image_, struct _map_data__seq_uniq_ > _map_data__seq;
                typedef DDS_DCPSSequence_var< _map_data__seq > _map_data__seq_var;
                typedef DDS_DCPSSequence_out< _map_data__seq > _map_data__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::geometry_msgs::msg::dds_::Point_ top_left_;
                ::geometry_msgs::msg::dds_::Point_ top_right_;
                ::geometry_msgs::msg::dds_::Point_ bottom_right_;
                ::geometry_msgs::msg::dds_::Point_ bottom_left_;
                _map_names__seq map_names_;
                _map_data__seq map_data_;
            };

            typedef DDS_DCPSStruct_var<GridMap_> GridMap__var;
            typedef DDS_DCPSStruct_out < GridMap_> GridMap__out;

        }

    }

}

#endif /* _H_95F24B6507C8E318327A1432EDE96D3E_GridMap__H_ */
