#ifndef _H_0B9ED27E14782BB8CDD21EE45911EFC6_LeadVehicle_DCPS_H_
#define _H_0B9ED27E14782BB8CDD21EE45911EFC6_LeadVehicle_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LeadVehicle_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LeadVehicle_TypeSupportInterface;

            typedef LeadVehicle_TypeSupportInterface * LeadVehicle_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LeadVehicle_TypeSupportInterface> LeadVehicle_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LeadVehicle_TypeSupportInterface> LeadVehicle_TypeSupportInterface_out;


            class LeadVehicle_DataWriter;

            typedef LeadVehicle_DataWriter * LeadVehicle_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LeadVehicle_DataWriter> LeadVehicle_DataWriter_var;
            typedef DDS_DCPSInterface_out < LeadVehicle_DataWriter> LeadVehicle_DataWriter_out;


            class LeadVehicle_DataReader;

            typedef LeadVehicle_DataReader * LeadVehicle_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LeadVehicle_DataReader> LeadVehicle_DataReader_var;
            typedef DDS_DCPSInterface_out < LeadVehicle_DataReader> LeadVehicle_DataReader_out;


            class LeadVehicle_DataReaderView;

            typedef LeadVehicle_DataReaderView * LeadVehicle_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LeadVehicle_DataReaderView> LeadVehicle_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LeadVehicle_DataReaderView> LeadVehicle_DataReaderView_out;

            struct LeadVehicle_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LeadVehicle_, struct LeadVehicle_Seq_uniq_> LeadVehicle_Seq;
            typedef DDS_DCPSSequence_var < LeadVehicle_Seq> LeadVehicle_Seq_var;
            typedef DDS_DCPSSequence_out < LeadVehicle_Seq> LeadVehicle_Seq_out;

            class  LeadVehicle_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LeadVehicle_TypeSupportInterface_ptr _ptr_type;
                typedef LeadVehicle_TypeSupportInterface_var _var_type;

                static LeadVehicle_TypeSupportInterface_ptr _duplicate (LeadVehicle_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LeadVehicle_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LeadVehicle_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LeadVehicle_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LeadVehicle_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LeadVehicle_TypeSupportInterface () {};
                ~LeadVehicle_TypeSupportInterface () {};
            private:
                LeadVehicle_TypeSupportInterface (const LeadVehicle_TypeSupportInterface &);
                LeadVehicle_TypeSupportInterface & operator = (const LeadVehicle_TypeSupportInterface &);
            };

            class  LeadVehicle_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LeadVehicle_DataWriter_ptr _ptr_type;
                typedef LeadVehicle_DataWriter_var _var_type;

                static LeadVehicle_DataWriter_ptr _duplicate (LeadVehicle_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LeadVehicle_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LeadVehicle_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LeadVehicle_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LeadVehicle_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LeadVehicle_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LeadVehicle_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LeadVehicle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LeadVehicle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LeadVehicle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LeadVehicle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LeadVehicle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LeadVehicle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LeadVehicle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LeadVehicle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LeadVehicle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LeadVehicle_& instance_data) = 0;

            protected:
                LeadVehicle_DataWriter () {};
                ~LeadVehicle_DataWriter () {};
            private:
                LeadVehicle_DataWriter (const LeadVehicle_DataWriter &);
                LeadVehicle_DataWriter & operator = (const LeadVehicle_DataWriter &);
            };

            class  LeadVehicle_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LeadVehicle_DataReader_ptr _ptr_type;
                typedef LeadVehicle_DataReader_var _var_type;

                static LeadVehicle_DataReader_ptr _duplicate (LeadVehicle_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LeadVehicle_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LeadVehicle_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LeadVehicle_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LeadVehicle_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LeadVehicle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LeadVehicle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LeadVehicle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LeadVehicle_& instance) = 0;

            protected:
                LeadVehicle_DataReader () {};
                ~LeadVehicle_DataReader () {};
            private:
                LeadVehicle_DataReader (const LeadVehicle_DataReader &);
                LeadVehicle_DataReader & operator = (const LeadVehicle_DataReader &);
            };

            class  LeadVehicle_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LeadVehicle_DataReaderView_ptr _ptr_type;
                typedef LeadVehicle_DataReaderView_var _var_type;

                static LeadVehicle_DataReaderView_ptr _duplicate (LeadVehicle_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LeadVehicle_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LeadVehicle_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LeadVehicle_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LeadVehicle_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LeadVehicle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LeadVehicle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LeadVehicle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LeadVehicle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LeadVehicle_& instance) = 0;

            protected:
                LeadVehicle_DataReaderView () {};
                ~LeadVehicle_DataReaderView () {};
            private:
                LeadVehicle_DataReaderView (const LeadVehicle_DataReaderView &);
                LeadVehicle_DataReaderView & operator = (const LeadVehicle_DataReaderView &);
            };
        }

    }

}

#endif
