#ifndef _H_17C73195EF65F41CD110F18B890B531B_ObstacleArray_DCPS_H_
#define _H_17C73195EF65F41CD110F18B890B531B_ObstacleArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObstacleArray_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObstacleArray_TypeSupportInterface;

            typedef ObstacleArray_TypeSupportInterface * ObstacleArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArray_TypeSupportInterface> ObstacleArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObstacleArray_TypeSupportInterface> ObstacleArray_TypeSupportInterface_out;


            class ObstacleArray_DataWriter;

            typedef ObstacleArray_DataWriter * ObstacleArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArray_DataWriter> ObstacleArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObstacleArray_DataWriter> ObstacleArray_DataWriter_out;


            class ObstacleArray_DataReader;

            typedef ObstacleArray_DataReader * ObstacleArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArray_DataReader> ObstacleArray_DataReader_var;
            typedef DDS_DCPSInterface_out < ObstacleArray_DataReader> ObstacleArray_DataReader_out;


            class ObstacleArray_DataReaderView;

            typedef ObstacleArray_DataReaderView * ObstacleArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObstacleArray_DataReaderView> ObstacleArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObstacleArray_DataReaderView> ObstacleArray_DataReaderView_out;

            struct ObstacleArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObstacleArray_, struct ObstacleArray_Seq_uniq_> ObstacleArray_Seq;
            typedef DDS_DCPSSequence_var < ObstacleArray_Seq> ObstacleArray_Seq_var;
            typedef DDS_DCPSSequence_out < ObstacleArray_Seq> ObstacleArray_Seq_out;

            class  ObstacleArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObstacleArray_TypeSupportInterface_ptr _ptr_type;
                typedef ObstacleArray_TypeSupportInterface_var _var_type;

                static ObstacleArray_TypeSupportInterface_ptr _duplicate (ObstacleArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObstacleArray_TypeSupportInterface () {};
                ~ObstacleArray_TypeSupportInterface () {};
            private:
                ObstacleArray_TypeSupportInterface (const ObstacleArray_TypeSupportInterface &);
                ObstacleArray_TypeSupportInterface & operator = (const ObstacleArray_TypeSupportInterface &);
            };

            class  ObstacleArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObstacleArray_DataWriter_ptr _ptr_type;
                typedef ObstacleArray_DataWriter_var _var_type;

                static ObstacleArray_DataWriter_ptr _duplicate (ObstacleArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObstacleArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObstacleArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObstacleArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObstacleArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObstacleArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObstacleArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObstacleArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObstacleArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObstacleArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObstacleArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObstacleArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleArray_& instance_data) = 0;

            protected:
                ObstacleArray_DataWriter () {};
                ~ObstacleArray_DataWriter () {};
            private:
                ObstacleArray_DataWriter (const ObstacleArray_DataWriter &);
                ObstacleArray_DataWriter & operator = (const ObstacleArray_DataWriter &);
            };

            class  ObstacleArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObstacleArray_DataReader_ptr _ptr_type;
                typedef ObstacleArray_DataReader_var _var_type;

                static ObstacleArray_DataReader_ptr _duplicate (ObstacleArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleArray_& instance) = 0;

            protected:
                ObstacleArray_DataReader () {};
                ~ObstacleArray_DataReader () {};
            private:
                ObstacleArray_DataReader (const ObstacleArray_DataReader &);
                ObstacleArray_DataReader & operator = (const ObstacleArray_DataReader &);
            };

            class  ObstacleArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObstacleArray_DataReaderView_ptr _ptr_type;
                typedef ObstacleArray_DataReaderView_var _var_type;

                static ObstacleArray_DataReaderView_ptr _duplicate (ObstacleArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObstacleArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObstacleArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObstacleArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObstacleArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObstacleArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObstacleArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObstacleArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObstacleArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObstacleArray_& instance) = 0;

            protected:
                ObstacleArray_DataReaderView () {};
                ~ObstacleArray_DataReaderView () {};
            private:
                ObstacleArray_DataReaderView (const ObstacleArray_DataReaderView &);
                ObstacleArray_DataReaderView & operator = (const ObstacleArray_DataReaderView &);
            };
        }

    }

}

#endif
