#ifndef _H_5876BAE56EC046610B50EE87BCE27283_RouteOffset_DCPS_H_
#define _H_5876BAE56EC046610B50EE87BCE27283_RouteOffset_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RouteOffset_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RouteOffset_TypeSupportInterface;

            typedef RouteOffset_TypeSupportInterface * RouteOffset_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RouteOffset_TypeSupportInterface> RouteOffset_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RouteOffset_TypeSupportInterface> RouteOffset_TypeSupportInterface_out;


            class RouteOffset_DataWriter;

            typedef RouteOffset_DataWriter * RouteOffset_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RouteOffset_DataWriter> RouteOffset_DataWriter_var;
            typedef DDS_DCPSInterface_out < RouteOffset_DataWriter> RouteOffset_DataWriter_out;


            class RouteOffset_DataReader;

            typedef RouteOffset_DataReader * RouteOffset_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RouteOffset_DataReader> RouteOffset_DataReader_var;
            typedef DDS_DCPSInterface_out < RouteOffset_DataReader> RouteOffset_DataReader_out;


            class RouteOffset_DataReaderView;

            typedef RouteOffset_DataReaderView * RouteOffset_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RouteOffset_DataReaderView> RouteOffset_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RouteOffset_DataReaderView> RouteOffset_DataReaderView_out;

            struct RouteOffset_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RouteOffset_, struct RouteOffset_Seq_uniq_> RouteOffset_Seq;
            typedef DDS_DCPSSequence_var < RouteOffset_Seq> RouteOffset_Seq_var;
            typedef DDS_DCPSSequence_out < RouteOffset_Seq> RouteOffset_Seq_out;

            class  RouteOffset_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RouteOffset_TypeSupportInterface_ptr _ptr_type;
                typedef RouteOffset_TypeSupportInterface_var _var_type;

                static RouteOffset_TypeSupportInterface_ptr _duplicate (RouteOffset_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteOffset_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RouteOffset_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteOffset_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteOffset_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RouteOffset_TypeSupportInterface () {};
                ~RouteOffset_TypeSupportInterface () {};
            private:
                RouteOffset_TypeSupportInterface (const RouteOffset_TypeSupportInterface &);
                RouteOffset_TypeSupportInterface & operator = (const RouteOffset_TypeSupportInterface &);
            };

            class  RouteOffset_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RouteOffset_DataWriter_ptr _ptr_type;
                typedef RouteOffset_DataWriter_var _var_type;

                static RouteOffset_DataWriter_ptr _duplicate (RouteOffset_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteOffset_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RouteOffset_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteOffset_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteOffset_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RouteOffset_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RouteOffset_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RouteOffset_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RouteOffset_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RouteOffset_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RouteOffset_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RouteOffset_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RouteOffset_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RouteOffset_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RouteOffset_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RouteOffset_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteOffset_& instance_data) = 0;

            protected:
                RouteOffset_DataWriter () {};
                ~RouteOffset_DataWriter () {};
            private:
                RouteOffset_DataWriter (const RouteOffset_DataWriter &);
                RouteOffset_DataWriter & operator = (const RouteOffset_DataWriter &);
            };

            class  RouteOffset_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RouteOffset_DataReader_ptr _ptr_type;
                typedef RouteOffset_DataReader_var _var_type;

                static RouteOffset_DataReader_ptr _duplicate (RouteOffset_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteOffset_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RouteOffset_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteOffset_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteOffset_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RouteOffset_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RouteOffset_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RouteOffset_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteOffset_& instance) = 0;

            protected:
                RouteOffset_DataReader () {};
                ~RouteOffset_DataReader () {};
            private:
                RouteOffset_DataReader (const RouteOffset_DataReader &);
                RouteOffset_DataReader & operator = (const RouteOffset_DataReader &);
            };

            class  RouteOffset_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RouteOffset_DataReaderView_ptr _ptr_type;
                typedef RouteOffset_DataReaderView_var _var_type;

                static RouteOffset_DataReaderView_ptr _duplicate (RouteOffset_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteOffset_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RouteOffset_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteOffset_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteOffset_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RouteOffset_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RouteOffset_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RouteOffset_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RouteOffset_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteOffset_& instance) = 0;

            protected:
                RouteOffset_DataReaderView () {};
                ~RouteOffset_DataReaderView () {};
            private:
                RouteOffset_DataReaderView (const RouteOffset_DataReaderView &);
                RouteOffset_DataReaderView & operator = (const RouteOffset_DataReaderView &);
            };
        }

    }

}

#endif
