#ifndef _H_787A2461AD87301E6F57CEA246EDBF24_Route__H_
#define _H_787A2461AD87301E6F57CEA246EDBF24_Route__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "marti_nav_msgs/msg/dds_opensplice/RoutePoint_.h"
#include "marti_common_msgs/msg/dds_opensplice/KeyValue_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Route_
            {
                struct _route_points__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::marti_nav_msgs::msg::dds_::RoutePoint_, struct _route_points__seq_uniq_ > _route_points__seq;
                typedef DDS_DCPSSequence_var< _route_points__seq > _route_points__seq_var;
                typedef DDS_DCPSSequence_out< _route_points__seq > _route_points__seq_out;
                struct _properties__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::marti_common_msgs::msg::dds_::KeyValue_, struct _properties__seq_uniq_ > _properties__seq;
                typedef DDS_DCPSSequence_var< _properties__seq > _properties__seq_var;
                typedef DDS_DCPSSequence_out< _properties__seq > _properties__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                _route_points__seq route_points_;
                _properties__seq properties_;
            };

            typedef DDS_DCPSStruct_var<Route_> Route__var;
            typedef DDS_DCPSStruct_out < Route_> Route__out;

        }

    }

}

#endif /* _H_787A2461AD87301E6F57CEA246EDBF24_Route__H_ */
