#ifndef _H_D1267E097AA9F4A238775A211DBADCE7_TeleopState_DCPS_H_
#define _H_D1267E097AA9F4A238775A211DBADCE7_TeleopState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TeleopState_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TeleopState_TypeSupportInterface;

            typedef TeleopState_TypeSupportInterface * TeleopState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TeleopState_TypeSupportInterface> TeleopState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TeleopState_TypeSupportInterface> TeleopState_TypeSupportInterface_out;


            class TeleopState_DataWriter;

            typedef TeleopState_DataWriter * TeleopState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TeleopState_DataWriter> TeleopState_DataWriter_var;
            typedef DDS_DCPSInterface_out < TeleopState_DataWriter> TeleopState_DataWriter_out;


            class TeleopState_DataReader;

            typedef TeleopState_DataReader * TeleopState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TeleopState_DataReader> TeleopState_DataReader_var;
            typedef DDS_DCPSInterface_out < TeleopState_DataReader> TeleopState_DataReader_out;


            class TeleopState_DataReaderView;

            typedef TeleopState_DataReaderView * TeleopState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TeleopState_DataReaderView> TeleopState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TeleopState_DataReaderView> TeleopState_DataReaderView_out;

            struct TeleopState_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TeleopState_, struct TeleopState_Seq_uniq_> TeleopState_Seq;
            typedef DDS_DCPSSequence_var < TeleopState_Seq> TeleopState_Seq_var;
            typedef DDS_DCPSSequence_out < TeleopState_Seq> TeleopState_Seq_out;

            class  TeleopState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TeleopState_TypeSupportInterface_ptr _ptr_type;
                typedef TeleopState_TypeSupportInterface_var _var_type;

                static TeleopState_TypeSupportInterface_ptr _duplicate (TeleopState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TeleopState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TeleopState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TeleopState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TeleopState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TeleopState_TypeSupportInterface () {};
                ~TeleopState_TypeSupportInterface () {};
            private:
                TeleopState_TypeSupportInterface (const TeleopState_TypeSupportInterface &);
                TeleopState_TypeSupportInterface & operator = (const TeleopState_TypeSupportInterface &);
            };

            class  TeleopState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TeleopState_DataWriter_ptr _ptr_type;
                typedef TeleopState_DataWriter_var _var_type;

                static TeleopState_DataWriter_ptr _duplicate (TeleopState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TeleopState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TeleopState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TeleopState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TeleopState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TeleopState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TeleopState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TeleopState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TeleopState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TeleopState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TeleopState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TeleopState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TeleopState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TeleopState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TeleopState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TeleopState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TeleopState_& instance_data) = 0;

            protected:
                TeleopState_DataWriter () {};
                ~TeleopState_DataWriter () {};
            private:
                TeleopState_DataWriter (const TeleopState_DataWriter &);
                TeleopState_DataWriter & operator = (const TeleopState_DataWriter &);
            };

            class  TeleopState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TeleopState_DataReader_ptr _ptr_type;
                typedef TeleopState_DataReader_var _var_type;

                static TeleopState_DataReader_ptr _duplicate (TeleopState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TeleopState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TeleopState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TeleopState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TeleopState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TeleopState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TeleopState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TeleopState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TeleopState_& instance) = 0;

            protected:
                TeleopState_DataReader () {};
                ~TeleopState_DataReader () {};
            private:
                TeleopState_DataReader (const TeleopState_DataReader &);
                TeleopState_DataReader & operator = (const TeleopState_DataReader &);
            };

            class  TeleopState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TeleopState_DataReaderView_ptr _ptr_type;
                typedef TeleopState_DataReaderView_var _var_type;

                static TeleopState_DataReaderView_ptr _duplicate (TeleopState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TeleopState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TeleopState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TeleopState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TeleopState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TeleopState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TeleopState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TeleopState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TeleopState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TeleopState_& instance) = 0;

            protected:
                TeleopState_DataReaderView () {};
                ~TeleopState_DataReaderView () {};
            private:
                TeleopState_DataReaderView (const TeleopState_DataReaderView &);
                TeleopState_DataReaderView & operator = (const TeleopState_DataReaderView &);
            };
        }

    }

}

#endif
