#ifndef _H_2C08315ED5DC04E5DD5761F62DDA325A_TrackedObjectArray_DCPS_H_
#define _H_2C08315ED5DC04E5DD5761F62DDA325A_TrackedObjectArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TrackedObjectArray_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TrackedObjectArray_TypeSupportInterface;

            typedef TrackedObjectArray_TypeSupportInterface * TrackedObjectArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TrackedObjectArray_TypeSupportInterface> TrackedObjectArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TrackedObjectArray_TypeSupportInterface> TrackedObjectArray_TypeSupportInterface_out;


            class TrackedObjectArray_DataWriter;

            typedef TrackedObjectArray_DataWriter * TrackedObjectArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TrackedObjectArray_DataWriter> TrackedObjectArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < TrackedObjectArray_DataWriter> TrackedObjectArray_DataWriter_out;


            class TrackedObjectArray_DataReader;

            typedef TrackedObjectArray_DataReader * TrackedObjectArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TrackedObjectArray_DataReader> TrackedObjectArray_DataReader_var;
            typedef DDS_DCPSInterface_out < TrackedObjectArray_DataReader> TrackedObjectArray_DataReader_out;


            class TrackedObjectArray_DataReaderView;

            typedef TrackedObjectArray_DataReaderView * TrackedObjectArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TrackedObjectArray_DataReaderView> TrackedObjectArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TrackedObjectArray_DataReaderView> TrackedObjectArray_DataReaderView_out;

            struct TrackedObjectArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TrackedObjectArray_, struct TrackedObjectArray_Seq_uniq_> TrackedObjectArray_Seq;
            typedef DDS_DCPSSequence_var < TrackedObjectArray_Seq> TrackedObjectArray_Seq_var;
            typedef DDS_DCPSSequence_out < TrackedObjectArray_Seq> TrackedObjectArray_Seq_out;

            class  TrackedObjectArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TrackedObjectArray_TypeSupportInterface_ptr _ptr_type;
                typedef TrackedObjectArray_TypeSupportInterface_var _var_type;

                static TrackedObjectArray_TypeSupportInterface_ptr _duplicate (TrackedObjectArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedObjectArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedObjectArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TrackedObjectArray_TypeSupportInterface () {};
                ~TrackedObjectArray_TypeSupportInterface () {};
            private:
                TrackedObjectArray_TypeSupportInterface (const TrackedObjectArray_TypeSupportInterface &);
                TrackedObjectArray_TypeSupportInterface & operator = (const TrackedObjectArray_TypeSupportInterface &);
            };

            class  TrackedObjectArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TrackedObjectArray_DataWriter_ptr _ptr_type;
                typedef TrackedObjectArray_DataWriter_var _var_type;

                static TrackedObjectArray_DataWriter_ptr _duplicate (TrackedObjectArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedObjectArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedObjectArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TrackedObjectArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TrackedObjectArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TrackedObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TrackedObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TrackedObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TrackedObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TrackedObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TrackedObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TrackedObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TrackedObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TrackedObjectArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackedObjectArray_& instance_data) = 0;

            protected:
                TrackedObjectArray_DataWriter () {};
                ~TrackedObjectArray_DataWriter () {};
            private:
                TrackedObjectArray_DataWriter (const TrackedObjectArray_DataWriter &);
                TrackedObjectArray_DataWriter & operator = (const TrackedObjectArray_DataWriter &);
            };

            class  TrackedObjectArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TrackedObjectArray_DataReader_ptr _ptr_type;
                typedef TrackedObjectArray_DataReader_var _var_type;

                static TrackedObjectArray_DataReader_ptr _duplicate (TrackedObjectArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedObjectArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedObjectArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackedObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackedObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackedObjectArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackedObjectArray_& instance) = 0;

            protected:
                TrackedObjectArray_DataReader () {};
                ~TrackedObjectArray_DataReader () {};
            private:
                TrackedObjectArray_DataReader (const TrackedObjectArray_DataReader &);
                TrackedObjectArray_DataReader & operator = (const TrackedObjectArray_DataReader &);
            };

            class  TrackedObjectArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TrackedObjectArray_DataReaderView_ptr _ptr_type;
                typedef TrackedObjectArray_DataReaderView_var _var_type;

                static TrackedObjectArray_DataReaderView_ptr _duplicate (TrackedObjectArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrackedObjectArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrackedObjectArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TrackedObjectArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrackedObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrackedObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrackedObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrackedObjectArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrackedObjectArray_& instance) = 0;

            protected:
                TrackedObjectArray_DataReaderView () {};
                ~TrackedObjectArray_DataReaderView () {};
            private:
                TrackedObjectArray_DataReaderView (const TrackedObjectArray_DataReaderView &);
                TrackedObjectArray_DataReaderView & operator = (const TrackedObjectArray_DataReaderView &);
            };
        }

    }

}

#endif
