#ifndef H_9BCAAB5DAFB991814FDA692A58A31007_TrackedObject_SPLTYPES_H
#define H_9BCAAB5DAFB991814FDA692A58A31007_TrackedObject_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_TrackedObject_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/PoseWithCovariance_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/TwistWithCovariance_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Point_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_SplDcps.h"



extern c_metaObject __TrackedObject__marti_nav_msgs__load (c_base base);

extern c_metaObject __TrackedObject__marti_nav_msgs_msg__load (c_base base);

extern c_metaObject __TrackedObject__marti_nav_msgs_msg_dds___load (c_base base);

extern c_metaObject __TrackedObject__marti_nav_msgs_msg_dds__TrackedObject_Constants__load (c_base base);

extern const char *marti_nav_msgs_msg_dds__TrackedObject__metaDescriptor[];
extern const int marti_nav_msgs_msg_dds__TrackedObject__metaDescriptorArrLength;
extern const int marti_nav_msgs_msg_dds__TrackedObject__metaDescriptorLength;
extern c_metaObject __marti_nav_msgs_msg_dds__TrackedObject___load (c_base base);
struct _marti_nav_msgs_msg_dds__TrackedObject_ ;
extern  v_copyin_result __marti_nav_msgs_msg_dds__TrackedObject___copyIn(c_base base, const struct marti_nav_msgs::msg::dds_::TrackedObject_ *from, struct _marti_nav_msgs_msg_dds__TrackedObject_ *to);
extern  void __marti_nav_msgs_msg_dds__TrackedObject___copyOut(const void *_from, void *_to);
struct _marti_nav_msgs_msg_dds__TrackedObject_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_ushort id_;
    struct _geometry_msgs_msg_dds__PoseWithCovariance_ pose_;
    struct _geometry_msgs_msg_dds__TwistWithCovariance_ velocity_;
    struct _geometry_msgs_msg_dds__Vector3_ linear_acceleration_;
    c_double linear_acceleration_covariance_[9];
    c_sequence polygon_;
    c_float length_;
    c_float length_quality_;
    c_float width_;
    c_float width_quality_;
    c_octet classification_;
    c_float classification_quality_;
    c_float existence_probability_;
    struct _builtin_interfaces_msg_dds__Duration_ age_duration_;
    struct _builtin_interfaces_msg_dds__Duration_ prediction_duration_;
    c_bool active_;
};

#undef OS_API
#endif
