#ifndef _H_FB17432A970DC76C462A31305C1CBD7C_VehicleControl__H_
#define _H_FB17432A970DC76C462A31305C1CBD7C_VehicleControl__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  VehicleControl_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Long engine_;
                ::DDS::Long gear_;
                ::DDS::Double steering_;
                ::DDS::Double throttle_;
                ::DDS::Double brake_;
                ::DDS::Short steering_position_;
                ::DDS::Short gb_position_;
            };

            typedef DDS_DCPSStruct_var<VehicleControl_> VehicleControl__var;
            typedef DDS_DCPSStruct_out < VehicleControl_> VehicleControl__out;

        }

    }

}

#endif /* _H_FB17432A970DC76C462A31305C1CBD7C_VehicleControl__H_ */
