#ifndef _H_FB17432A970DC76C462A31305C1CBD7C_VehicleControl_DCPS_H_
#define _H_FB17432A970DC76C462A31305C1CBD7C_VehicleControl_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleControl_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleControl_TypeSupportInterface;

            typedef VehicleControl_TypeSupportInterface * VehicleControl_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleControl_TypeSupportInterface> VehicleControl_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleControl_TypeSupportInterface> VehicleControl_TypeSupportInterface_out;


            class VehicleControl_DataWriter;

            typedef VehicleControl_DataWriter * VehicleControl_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleControl_DataWriter> VehicleControl_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleControl_DataWriter> VehicleControl_DataWriter_out;


            class VehicleControl_DataReader;

            typedef VehicleControl_DataReader * VehicleControl_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleControl_DataReader> VehicleControl_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleControl_DataReader> VehicleControl_DataReader_out;


            class VehicleControl_DataReaderView;

            typedef VehicleControl_DataReaderView * VehicleControl_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleControl_DataReaderView> VehicleControl_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleControl_DataReaderView> VehicleControl_DataReaderView_out;

            struct VehicleControl_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleControl_, struct VehicleControl_Seq_uniq_> VehicleControl_Seq;
            typedef DDS_DCPSSequence_var < VehicleControl_Seq> VehicleControl_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleControl_Seq> VehicleControl_Seq_out;

            class  VehicleControl_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleControl_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleControl_TypeSupportInterface_var _var_type;

                static VehicleControl_TypeSupportInterface_ptr _duplicate (VehicleControl_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControl_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControl_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControl_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControl_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleControl_TypeSupportInterface () {};
                ~VehicleControl_TypeSupportInterface () {};
            private:
                VehicleControl_TypeSupportInterface (const VehicleControl_TypeSupportInterface &);
                VehicleControl_TypeSupportInterface & operator = (const VehicleControl_TypeSupportInterface &);
            };

            class  VehicleControl_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleControl_DataWriter_ptr _ptr_type;
                typedef VehicleControl_DataWriter_var _var_type;

                static VehicleControl_DataWriter_ptr _duplicate (VehicleControl_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControl_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControl_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControl_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControl_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleControl_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleControl_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleControl_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleControl_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControl_& instance_data) = 0;

            protected:
                VehicleControl_DataWriter () {};
                ~VehicleControl_DataWriter () {};
            private:
                VehicleControl_DataWriter (const VehicleControl_DataWriter &);
                VehicleControl_DataWriter & operator = (const VehicleControl_DataWriter &);
            };

            class  VehicleControl_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleControl_DataReader_ptr _ptr_type;
                typedef VehicleControl_DataReader_var _var_type;

                static VehicleControl_DataReader_ptr _duplicate (VehicleControl_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControl_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControl_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControl_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControl_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControl_& instance) = 0;

            protected:
                VehicleControl_DataReader () {};
                ~VehicleControl_DataReader () {};
            private:
                VehicleControl_DataReader (const VehicleControl_DataReader &);
                VehicleControl_DataReader & operator = (const VehicleControl_DataReader &);
            };

            class  VehicleControl_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleControl_DataReaderView_ptr _ptr_type;
                typedef VehicleControl_DataReaderView_var _var_type;

                static VehicleControl_DataReaderView_ptr _duplicate (VehicleControl_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControl_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControl_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControl_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControl_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleControl_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleControl_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleControl_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControl_& instance) = 0;

            protected:
                VehicleControl_DataReaderView () {};
                ~VehicleControl_DataReaderView () {};
            private:
                VehicleControl_DataReaderView (const VehicleControl_DataReaderView &);
                VehicleControl_DataReaderView & operator = (const VehicleControl_DataReaderView &);
            };
        }

    }

}

#endif
