#ifndef _H_B5C4985A213D2E28C3D3CDE5F15037B3_Wgs84Sample_DCPS_H_
#define _H_B5C4985A213D2E28C3D3CDE5F15037B3_Wgs84Sample_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Wgs84Sample_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Wgs84Sample_TypeSupportInterface;

            typedef Wgs84Sample_TypeSupportInterface * Wgs84Sample_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wgs84Sample_TypeSupportInterface> Wgs84Sample_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wgs84Sample_TypeSupportInterface> Wgs84Sample_TypeSupportInterface_out;


            class Wgs84Sample_DataWriter;

            typedef Wgs84Sample_DataWriter * Wgs84Sample_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wgs84Sample_DataWriter> Wgs84Sample_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wgs84Sample_DataWriter> Wgs84Sample_DataWriter_out;


            class Wgs84Sample_DataReader;

            typedef Wgs84Sample_DataReader * Wgs84Sample_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wgs84Sample_DataReader> Wgs84Sample_DataReader_var;
            typedef DDS_DCPSInterface_out < Wgs84Sample_DataReader> Wgs84Sample_DataReader_out;


            class Wgs84Sample_DataReaderView;

            typedef Wgs84Sample_DataReaderView * Wgs84Sample_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wgs84Sample_DataReaderView> Wgs84Sample_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wgs84Sample_DataReaderView> Wgs84Sample_DataReaderView_out;

            struct Wgs84Sample_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Wgs84Sample_, struct Wgs84Sample_Seq_uniq_> Wgs84Sample_Seq;
            typedef DDS_DCPSSequence_var < Wgs84Sample_Seq> Wgs84Sample_Seq_var;
            typedef DDS_DCPSSequence_out < Wgs84Sample_Seq> Wgs84Sample_Seq_out;

            class  Wgs84Sample_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wgs84Sample_TypeSupportInterface_ptr _ptr_type;
                typedef Wgs84Sample_TypeSupportInterface_var _var_type;

                static Wgs84Sample_TypeSupportInterface_ptr _duplicate (Wgs84Sample_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wgs84Sample_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wgs84Sample_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wgs84Sample_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wgs84Sample_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wgs84Sample_TypeSupportInterface () {};
                ~Wgs84Sample_TypeSupportInterface () {};
            private:
                Wgs84Sample_TypeSupportInterface (const Wgs84Sample_TypeSupportInterface &);
                Wgs84Sample_TypeSupportInterface & operator = (const Wgs84Sample_TypeSupportInterface &);
            };

            class  Wgs84Sample_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wgs84Sample_DataWriter_ptr _ptr_type;
                typedef Wgs84Sample_DataWriter_var _var_type;

                static Wgs84Sample_DataWriter_ptr _duplicate (Wgs84Sample_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wgs84Sample_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wgs84Sample_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wgs84Sample_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wgs84Sample_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wgs84Sample_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wgs84Sample_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wgs84Sample_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wgs84Sample_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wgs84Sample_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wgs84Sample_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wgs84Sample_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wgs84Sample_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wgs84Sample_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wgs84Sample_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wgs84Sample_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wgs84Sample_& instance_data) = 0;

            protected:
                Wgs84Sample_DataWriter () {};
                ~Wgs84Sample_DataWriter () {};
            private:
                Wgs84Sample_DataWriter (const Wgs84Sample_DataWriter &);
                Wgs84Sample_DataWriter & operator = (const Wgs84Sample_DataWriter &);
            };

            class  Wgs84Sample_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wgs84Sample_DataReader_ptr _ptr_type;
                typedef Wgs84Sample_DataReader_var _var_type;

                static Wgs84Sample_DataReader_ptr _duplicate (Wgs84Sample_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wgs84Sample_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wgs84Sample_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wgs84Sample_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wgs84Sample_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wgs84Sample_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wgs84Sample_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wgs84Sample_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wgs84Sample_& instance) = 0;

            protected:
                Wgs84Sample_DataReader () {};
                ~Wgs84Sample_DataReader () {};
            private:
                Wgs84Sample_DataReader (const Wgs84Sample_DataReader &);
                Wgs84Sample_DataReader & operator = (const Wgs84Sample_DataReader &);
            };

            class  Wgs84Sample_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wgs84Sample_DataReaderView_ptr _ptr_type;
                typedef Wgs84Sample_DataReaderView_var _var_type;

                static Wgs84Sample_DataReaderView_ptr _duplicate (Wgs84Sample_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wgs84Sample_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wgs84Sample_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wgs84Sample_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wgs84Sample_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wgs84Sample_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wgs84Sample_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wgs84Sample_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wgs84Sample_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wgs84Sample_& instance) = 0;

            protected:
                Wgs84Sample_DataReaderView () {};
                ~Wgs84Sample_DataReaderView () {};
            private:
                Wgs84Sample_DataReaderView (const Wgs84Sample_DataReaderView &);
                Wgs84Sample_DataReaderView & operator = (const Wgs84Sample_DataReaderView &);
            };
        }

    }

}

#endif
