// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/GridMap.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/grid_map__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `top_left`
// Member `top_right`
// Member `bottom_right`
// Member `bottom_left`
#include "geometry_msgs/msg/point__functions.h"
// Member `map_names`
#include "rosidl_generator_c/string_functions.h"
// Member `map_data`
#include "sensor_msgs/msg/image__functions.h"

bool
marti_nav_msgs__msg__GridMap__init(marti_nav_msgs__msg__GridMap * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__msg__GridMap__fini(msg);
    return false;
  }
  // top_left
  if (!geometry_msgs__msg__Point__init(&msg->top_left)) {
    marti_nav_msgs__msg__GridMap__fini(msg);
    return false;
  }
  // top_right
  if (!geometry_msgs__msg__Point__init(&msg->top_right)) {
    marti_nav_msgs__msg__GridMap__fini(msg);
    return false;
  }
  // bottom_right
  if (!geometry_msgs__msg__Point__init(&msg->bottom_right)) {
    marti_nav_msgs__msg__GridMap__fini(msg);
    return false;
  }
  // bottom_left
  if (!geometry_msgs__msg__Point__init(&msg->bottom_left)) {
    marti_nav_msgs__msg__GridMap__fini(msg);
    return false;
  }
  // map_names
  if (!rosidl_generator_c__String__Sequence__init(&msg->map_names, 0)) {
    marti_nav_msgs__msg__GridMap__fini(msg);
    return false;
  }
  // map_data
  if (!sensor_msgs__msg__Image__Sequence__init(&msg->map_data, 0)) {
    marti_nav_msgs__msg__GridMap__fini(msg);
    return false;
  }
  return true;
}

void
marti_nav_msgs__msg__GridMap__fini(marti_nav_msgs__msg__GridMap * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // top_left
  geometry_msgs__msg__Point__fini(&msg->top_left);
  // top_right
  geometry_msgs__msg__Point__fini(&msg->top_right);
  // bottom_right
  geometry_msgs__msg__Point__fini(&msg->bottom_right);
  // bottom_left
  geometry_msgs__msg__Point__fini(&msg->bottom_left);
  // map_names
  rosidl_generator_c__String__Sequence__fini(&msg->map_names);
  // map_data
  sensor_msgs__msg__Image__Sequence__fini(&msg->map_data);
}

marti_nav_msgs__msg__GridMap *
marti_nav_msgs__msg__GridMap__create()
{
  marti_nav_msgs__msg__GridMap * msg = (marti_nav_msgs__msg__GridMap *)malloc(sizeof(marti_nav_msgs__msg__GridMap));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__GridMap));
  bool success = marti_nav_msgs__msg__GridMap__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__GridMap__destroy(marti_nav_msgs__msg__GridMap * msg)
{
  if (msg) {
    marti_nav_msgs__msg__GridMap__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__GridMap__Sequence__init(marti_nav_msgs__msg__GridMap__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__GridMap * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__GridMap *)calloc(size, sizeof(marti_nav_msgs__msg__GridMap));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__GridMap__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__GridMap__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__GridMap__Sequence__fini(marti_nav_msgs__msg__GridMap__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__GridMap__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__GridMap__Sequence *
marti_nav_msgs__msg__GridMap__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__GridMap__Sequence * array = (marti_nav_msgs__msg__GridMap__Sequence *)malloc(sizeof(marti_nav_msgs__msg__GridMap__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__GridMap__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__GridMap__Sequence__destroy(marti_nav_msgs__msg__GridMap__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__GridMap__Sequence__fini(array);
  }
  free(array);
}
