// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/Obstacle.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/obstacle__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `id`
#include "rosidl_generator_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/pose__functions.h"
// Member `polygon`
#include "geometry_msgs/msg/point__functions.h"

bool
marti_nav_msgs__msg__Obstacle__init(marti_nav_msgs__msg__Obstacle * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_generator_c__String__init(&msg->id)) {
    marti_nav_msgs__msg__Obstacle__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    marti_nav_msgs__msg__Obstacle__fini(msg);
    return false;
  }
  // polygon
  if (!geometry_msgs__msg__Point__Sequence__init(&msg->polygon, 0)) {
    marti_nav_msgs__msg__Obstacle__fini(msg);
    return false;
  }
  return true;
}

void
marti_nav_msgs__msg__Obstacle__fini(marti_nav_msgs__msg__Obstacle * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_generator_c__String__fini(&msg->id);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // polygon
  geometry_msgs__msg__Point__Sequence__fini(&msg->polygon);
}

marti_nav_msgs__msg__Obstacle *
marti_nav_msgs__msg__Obstacle__create()
{
  marti_nav_msgs__msg__Obstacle * msg = (marti_nav_msgs__msg__Obstacle *)malloc(sizeof(marti_nav_msgs__msg__Obstacle));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__Obstacle));
  bool success = marti_nav_msgs__msg__Obstacle__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__Obstacle__destroy(marti_nav_msgs__msg__Obstacle * msg)
{
  if (msg) {
    marti_nav_msgs__msg__Obstacle__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__Obstacle__Sequence__init(marti_nav_msgs__msg__Obstacle__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__Obstacle * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__Obstacle *)calloc(size, sizeof(marti_nav_msgs__msg__Obstacle));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__Obstacle__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__Obstacle__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__Obstacle__Sequence__fini(marti_nav_msgs__msg__Obstacle__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__Obstacle__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__Obstacle__Sequence *
marti_nav_msgs__msg__Obstacle__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__Obstacle__Sequence * array = (marti_nav_msgs__msg__Obstacle__Sequence *)malloc(sizeof(marti_nav_msgs__msg__Obstacle__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__Obstacle__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__Obstacle__Sequence__destroy(marti_nav_msgs__msg__Obstacle__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__Obstacle__Sequence__fini(array);
  }
  free(array);
}
