// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marti_nav_msgs:msg/ObstacleArray.idl
// generated code does not contain a copyright notice

#ifndef MARTI_NAV_MSGS__MSG__OBSTACLE_ARRAY__FUNCTIONS_H_
#define MARTI_NAV_MSGS__MSG__OBSTACLE_ARRAY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "marti_nav_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "marti_nav_msgs/msg/obstacle_array__struct.h"

/// Initialize msg/ObstacleArray message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marti_nav_msgs__msg__ObstacleArray
 * )) before or use
 * marti_nav_msgs__msg__ObstacleArray__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
bool
marti_nav_msgs__msg__ObstacleArray__init(marti_nav_msgs__msg__ObstacleArray * msg);

/// Finalize msg/ObstacleArray message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__msg__ObstacleArray__fini(marti_nav_msgs__msg__ObstacleArray * msg);

/// Create msg/ObstacleArray message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marti_nav_msgs__msg__ObstacleArray__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
marti_nav_msgs__msg__ObstacleArray *
marti_nav_msgs__msg__ObstacleArray__create();

/// Destroy msg/ObstacleArray message.
/**
 * It calls
 * marti_nav_msgs__msg__ObstacleArray__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__msg__ObstacleArray__destroy(marti_nav_msgs__msg__ObstacleArray * msg);


/// Initialize array of msg/ObstacleArray messages.
/**
 * It allocates the memory for the number of elements and calls
 * marti_nav_msgs__msg__ObstacleArray__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
bool
marti_nav_msgs__msg__ObstacleArray__Sequence__init(marti_nav_msgs__msg__ObstacleArray__Sequence * array, size_t size);

/// Finalize array of msg/ObstacleArray messages.
/**
 * It calls
 * marti_nav_msgs__msg__ObstacleArray__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__msg__ObstacleArray__Sequence__fini(marti_nav_msgs__msg__ObstacleArray__Sequence * array);

/// Create array of msg/ObstacleArray messages.
/**
 * It allocates the memory for the array and calls
 * marti_nav_msgs__msg__ObstacleArray__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
marti_nav_msgs__msg__ObstacleArray__Sequence *
marti_nav_msgs__msg__ObstacleArray__Sequence__create(size_t size);

/// Destroy array of msg/ObstacleArray messages.
/**
 * It calls
 * marti_nav_msgs__msg__ObstacleArray__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__msg__ObstacleArray__Sequence__destroy(marti_nav_msgs__msg__ObstacleArray__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // MARTI_NAV_MSGS__MSG__OBSTACLE_ARRAY__FUNCTIONS_H_
