// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/RouteOffset.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/route_offset__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `relative_pose`
#include "geometry_msgs/msg/pose__functions.h"
// Member `route_position`
#include "marti_nav_msgs/msg/route_position__functions.h"

bool
marti_nav_msgs__msg__RouteOffset__init(marti_nav_msgs__msg__RouteOffset * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__msg__RouteOffset__fini(msg);
    return false;
  }
  // relative_pose
  if (!geometry_msgs__msg__Pose__init(&msg->relative_pose)) {
    marti_nav_msgs__msg__RouteOffset__fini(msg);
    return false;
  }
  // route_position
  if (!marti_nav_msgs__msg__RoutePosition__init(&msg->route_position)) {
    marti_nav_msgs__msg__RouteOffset__fini(msg);
    return false;
  }
  return true;
}

void
marti_nav_msgs__msg__RouteOffset__fini(marti_nav_msgs__msg__RouteOffset * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // relative_pose
  geometry_msgs__msg__Pose__fini(&msg->relative_pose);
  // route_position
  marti_nav_msgs__msg__RoutePosition__fini(&msg->route_position);
}

marti_nav_msgs__msg__RouteOffset *
marti_nav_msgs__msg__RouteOffset__create()
{
  marti_nav_msgs__msg__RouteOffset * msg = (marti_nav_msgs__msg__RouteOffset *)malloc(sizeof(marti_nav_msgs__msg__RouteOffset));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__RouteOffset));
  bool success = marti_nav_msgs__msg__RouteOffset__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__RouteOffset__destroy(marti_nav_msgs__msg__RouteOffset * msg)
{
  if (msg) {
    marti_nav_msgs__msg__RouteOffset__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__RouteOffset__Sequence__init(marti_nav_msgs__msg__RouteOffset__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__RouteOffset * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__RouteOffset *)calloc(size, sizeof(marti_nav_msgs__msg__RouteOffset));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__RouteOffset__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__RouteOffset__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__RouteOffset__Sequence__fini(marti_nav_msgs__msg__RouteOffset__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__RouteOffset__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__RouteOffset__Sequence *
marti_nav_msgs__msg__RouteOffset__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__RouteOffset__Sequence * array = (marti_nav_msgs__msg__RouteOffset__Sequence *)malloc(sizeof(marti_nav_msgs__msg__RouteOffset__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__RouteOffset__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__RouteOffset__Sequence__destroy(marti_nav_msgs__msg__RouteOffset__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__RouteOffset__Sequence__fini(array);
  }
  free(array);
}
