// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/RouteSpeedArray.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/route_speed_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `speeds`
#include "marti_nav_msgs/msg/route_speed__functions.h"

bool
marti_nav_msgs__msg__RouteSpeedArray__init(marti_nav_msgs__msg__RouteSpeedArray * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__msg__RouteSpeedArray__fini(msg);
    return false;
  }
  // speeds
  if (!marti_nav_msgs__msg__RouteSpeed__Sequence__init(&msg->speeds, 0)) {
    marti_nav_msgs__msg__RouteSpeedArray__fini(msg);
    return false;
  }
  return true;
}

void
marti_nav_msgs__msg__RouteSpeedArray__fini(marti_nav_msgs__msg__RouteSpeedArray * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // speeds
  marti_nav_msgs__msg__RouteSpeed__Sequence__fini(&msg->speeds);
}

marti_nav_msgs__msg__RouteSpeedArray *
marti_nav_msgs__msg__RouteSpeedArray__create()
{
  marti_nav_msgs__msg__RouteSpeedArray * msg = (marti_nav_msgs__msg__RouteSpeedArray *)malloc(sizeof(marti_nav_msgs__msg__RouteSpeedArray));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__RouteSpeedArray));
  bool success = marti_nav_msgs__msg__RouteSpeedArray__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__RouteSpeedArray__destroy(marti_nav_msgs__msg__RouteSpeedArray * msg)
{
  if (msg) {
    marti_nav_msgs__msg__RouteSpeedArray__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__RouteSpeedArray__Sequence__init(marti_nav_msgs__msg__RouteSpeedArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__RouteSpeedArray * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__RouteSpeedArray *)calloc(size, sizeof(marti_nav_msgs__msg__RouteSpeedArray));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__RouteSpeedArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__RouteSpeedArray__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__RouteSpeedArray__Sequence__fini(marti_nav_msgs__msg__RouteSpeedArray__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__RouteSpeedArray__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__RouteSpeedArray__Sequence *
marti_nav_msgs__msg__RouteSpeedArray__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__RouteSpeedArray__Sequence * array = (marti_nav_msgs__msg__RouteSpeedArray__Sequence *)malloc(sizeof(marti_nav_msgs__msg__RouteSpeedArray__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__RouteSpeedArray__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__RouteSpeedArray__Sequence__destroy(marti_nav_msgs__msg__RouteSpeedArray__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__RouteSpeedArray__Sequence__fini(array);
  }
  free(array);
}
