// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/TrackedObject.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/tracked_object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `pose`
#include "geometry_msgs/msg/pose_with_covariance__functions.h"
// Member `velocity`
#include "geometry_msgs/msg/twist_with_covariance__functions.h"
// Member `linear_acceleration`
#include "geometry_msgs/msg/vector3__functions.h"
// Member `polygon`
#include "geometry_msgs/msg/point__functions.h"
// Member `age_duration`
// Member `prediction_duration`
#include "builtin_interfaces/msg/duration__functions.h"

bool
marti_nav_msgs__msg__TrackedObject__init(marti_nav_msgs__msg__TrackedObject * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
    return false;
  }
  // id
  // pose
  if (!geometry_msgs__msg__PoseWithCovariance__init(&msg->pose)) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__TwistWithCovariance__init(&msg->velocity)) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
    return false;
  }
  // linear_acceleration
  if (!geometry_msgs__msg__Vector3__init(&msg->linear_acceleration)) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
    return false;
  }
  // linear_acceleration_covariance
  // polygon
  if (!geometry_msgs__msg__Point__Sequence__init(&msg->polygon, 0)) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
    return false;
  }
  // length
  // length_quality
  // width
  // width_quality
  // classification
  // classification_quality
  // existence_probability
  // age_duration
  if (!builtin_interfaces__msg__Duration__init(&msg->age_duration)) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
    return false;
  }
  // prediction_duration
  if (!builtin_interfaces__msg__Duration__init(&msg->prediction_duration)) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
    return false;
  }
  // active
  return true;
}

void
marti_nav_msgs__msg__TrackedObject__fini(marti_nav_msgs__msg__TrackedObject * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  // pose
  geometry_msgs__msg__PoseWithCovariance__fini(&msg->pose);
  // velocity
  geometry_msgs__msg__TwistWithCovariance__fini(&msg->velocity);
  // linear_acceleration
  geometry_msgs__msg__Vector3__fini(&msg->linear_acceleration);
  // linear_acceleration_covariance
  // polygon
  geometry_msgs__msg__Point__Sequence__fini(&msg->polygon);
  // length
  // length_quality
  // width
  // width_quality
  // classification
  // classification_quality
  // existence_probability
  // age_duration
  builtin_interfaces__msg__Duration__fini(&msg->age_duration);
  // prediction_duration
  builtin_interfaces__msg__Duration__fini(&msg->prediction_duration);
  // active
}

marti_nav_msgs__msg__TrackedObject *
marti_nav_msgs__msg__TrackedObject__create()
{
  marti_nav_msgs__msg__TrackedObject * msg = (marti_nav_msgs__msg__TrackedObject *)malloc(sizeof(marti_nav_msgs__msg__TrackedObject));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__TrackedObject));
  bool success = marti_nav_msgs__msg__TrackedObject__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__TrackedObject__destroy(marti_nav_msgs__msg__TrackedObject * msg)
{
  if (msg) {
    marti_nav_msgs__msg__TrackedObject__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__TrackedObject__Sequence__init(marti_nav_msgs__msg__TrackedObject__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__TrackedObject * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__TrackedObject *)calloc(size, sizeof(marti_nav_msgs__msg__TrackedObject));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__TrackedObject__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__TrackedObject__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__TrackedObject__Sequence__fini(marti_nav_msgs__msg__TrackedObject__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__TrackedObject__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__TrackedObject__Sequence *
marti_nav_msgs__msg__TrackedObject__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__TrackedObject__Sequence * array = (marti_nav_msgs__msg__TrackedObject__Sequence *)malloc(sizeof(marti_nav_msgs__msg__TrackedObject__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__TrackedObject__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__TrackedObject__Sequence__destroy(marti_nav_msgs__msg__TrackedObject__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__TrackedObject__Sequence__fini(array);
  }
  free(array);
}
