#ifndef _H_689C16816A7752942766BE6B3A7E2493_GetRouteList__H_
#define _H_689C16816A7752942766BE6B3A7E2493_GetRouteList__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "marti_nav_msgs/msg/dds_opensplice/Route_.h"


namespace marti_nav_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetRouteList_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<GetRouteList_Request_> GetRouteList_Request__var;
            typedef GetRouteList_Request_& GetRouteList_Request__out;

            struct  GetRouteList_Response_
            {
                struct _routes__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::marti_nav_msgs::msg::dds_::Route_, struct _routes__seq_uniq_ > _routes__seq;
                typedef DDS_DCPSSequence_var< _routes__seq > _routes__seq_var;
                typedef DDS_DCPSSequence_out< _routes__seq > _routes__seq_out;
                _routes__seq routes_;
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<GetRouteList_Response_> GetRouteList_Response__var;
            typedef DDS_DCPSStruct_out < GetRouteList_Response_> GetRouteList_Response__out;

            struct  Sample_GetRouteList_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::marti_nav_msgs::srv::dds_::GetRouteList_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRouteList_Request_> Sample_GetRouteList_Request__var;
            typedef Sample_GetRouteList_Request_& Sample_GetRouteList_Request__out;

            struct  Sample_GetRouteList_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::marti_nav_msgs::srv::dds_::GetRouteList_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRouteList_Response_> Sample_GetRouteList_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetRouteList_Response_> Sample_GetRouteList_Response__out;

        }

    }

}

#endif /* _H_689C16816A7752942766BE6B3A7E2493_GetRouteList__H_ */
