#ifndef _H_D91251AC372A77344DCBED613661F0CE_GetRoute_DCPS_H_
#define _H_D91251AC372A77344DCBED613661F0CE_GetRoute_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetRoute_.h"


namespace marti_nav_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetRoute_Request_TypeSupportInterface;

            typedef GetRoute_Request_TypeSupportInterface * GetRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Request_TypeSupportInterface> GetRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetRoute_Request_TypeSupportInterface> GetRoute_Request_TypeSupportInterface_out;


            class GetRoute_Request_DataWriter;

            typedef GetRoute_Request_DataWriter * GetRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Request_DataWriter> GetRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetRoute_Request_DataWriter> GetRoute_Request_DataWriter_out;


            class GetRoute_Request_DataReader;

            typedef GetRoute_Request_DataReader * GetRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Request_DataReader> GetRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetRoute_Request_DataReader> GetRoute_Request_DataReader_out;


            class GetRoute_Request_DataReaderView;

            typedef GetRoute_Request_DataReaderView * GetRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Request_DataReaderView> GetRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetRoute_Request_DataReaderView> GetRoute_Request_DataReaderView_out;

            struct GetRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetRoute_Request_, struct GetRoute_Request_Seq_uniq_> GetRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < GetRoute_Request_Seq> GetRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetRoute_Request_Seq> GetRoute_Request_Seq_out;

            class  GetRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetRoute_Request_TypeSupportInterface_var _var_type;

                static GetRoute_Request_TypeSupportInterface_ptr _duplicate (GetRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetRoute_Request_TypeSupportInterface () {};
                ~GetRoute_Request_TypeSupportInterface () {};
            private:
                GetRoute_Request_TypeSupportInterface (const GetRoute_Request_TypeSupportInterface &);
                GetRoute_Request_TypeSupportInterface & operator = (const GetRoute_Request_TypeSupportInterface &);
            };

            class  GetRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetRoute_Request_DataWriter_ptr _ptr_type;
                typedef GetRoute_Request_DataWriter_var _var_type;

                static GetRoute_Request_DataWriter_ptr _duplicate (GetRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoute_Request_& instance_data) = 0;

            protected:
                GetRoute_Request_DataWriter () {};
                ~GetRoute_Request_DataWriter () {};
            private:
                GetRoute_Request_DataWriter (const GetRoute_Request_DataWriter &);
                GetRoute_Request_DataWriter & operator = (const GetRoute_Request_DataWriter &);
            };

            class  GetRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetRoute_Request_DataReader_ptr _ptr_type;
                typedef GetRoute_Request_DataReader_var _var_type;

                static GetRoute_Request_DataReader_ptr _duplicate (GetRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoute_Request_& instance) = 0;

            protected:
                GetRoute_Request_DataReader () {};
                ~GetRoute_Request_DataReader () {};
            private:
                GetRoute_Request_DataReader (const GetRoute_Request_DataReader &);
                GetRoute_Request_DataReader & operator = (const GetRoute_Request_DataReader &);
            };

            class  GetRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetRoute_Request_DataReaderView_ptr _ptr_type;
                typedef GetRoute_Request_DataReaderView_var _var_type;

                static GetRoute_Request_DataReaderView_ptr _duplicate (GetRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoute_Request_& instance) = 0;

            protected:
                GetRoute_Request_DataReaderView () {};
                ~GetRoute_Request_DataReaderView () {};
            private:
                GetRoute_Request_DataReaderView (const GetRoute_Request_DataReaderView &);
                GetRoute_Request_DataReaderView & operator = (const GetRoute_Request_DataReaderView &);
            };
            class GetRoute_Response_TypeSupportInterface;

            typedef GetRoute_Response_TypeSupportInterface * GetRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Response_TypeSupportInterface> GetRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetRoute_Response_TypeSupportInterface> GetRoute_Response_TypeSupportInterface_out;


            class GetRoute_Response_DataWriter;

            typedef GetRoute_Response_DataWriter * GetRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Response_DataWriter> GetRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetRoute_Response_DataWriter> GetRoute_Response_DataWriter_out;


            class GetRoute_Response_DataReader;

            typedef GetRoute_Response_DataReader * GetRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Response_DataReader> GetRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetRoute_Response_DataReader> GetRoute_Response_DataReader_out;


            class GetRoute_Response_DataReaderView;

            typedef GetRoute_Response_DataReaderView * GetRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetRoute_Response_DataReaderView> GetRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetRoute_Response_DataReaderView> GetRoute_Response_DataReaderView_out;

            struct GetRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetRoute_Response_, struct GetRoute_Response_Seq_uniq_> GetRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < GetRoute_Response_Seq> GetRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetRoute_Response_Seq> GetRoute_Response_Seq_out;

            class  GetRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetRoute_Response_TypeSupportInterface_var _var_type;

                static GetRoute_Response_TypeSupportInterface_ptr _duplicate (GetRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetRoute_Response_TypeSupportInterface () {};
                ~GetRoute_Response_TypeSupportInterface () {};
            private:
                GetRoute_Response_TypeSupportInterface (const GetRoute_Response_TypeSupportInterface &);
                GetRoute_Response_TypeSupportInterface & operator = (const GetRoute_Response_TypeSupportInterface &);
            };

            class  GetRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetRoute_Response_DataWriter_ptr _ptr_type;
                typedef GetRoute_Response_DataWriter_var _var_type;

                static GetRoute_Response_DataWriter_ptr _duplicate (GetRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoute_Response_& instance_data) = 0;

            protected:
                GetRoute_Response_DataWriter () {};
                ~GetRoute_Response_DataWriter () {};
            private:
                GetRoute_Response_DataWriter (const GetRoute_Response_DataWriter &);
                GetRoute_Response_DataWriter & operator = (const GetRoute_Response_DataWriter &);
            };

            class  GetRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetRoute_Response_DataReader_ptr _ptr_type;
                typedef GetRoute_Response_DataReader_var _var_type;

                static GetRoute_Response_DataReader_ptr _duplicate (GetRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoute_Response_& instance) = 0;

            protected:
                GetRoute_Response_DataReader () {};
                ~GetRoute_Response_DataReader () {};
            private:
                GetRoute_Response_DataReader (const GetRoute_Response_DataReader &);
                GetRoute_Response_DataReader & operator = (const GetRoute_Response_DataReader &);
            };

            class  GetRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetRoute_Response_DataReaderView_ptr _ptr_type;
                typedef GetRoute_Response_DataReaderView_var _var_type;

                static GetRoute_Response_DataReaderView_ptr _duplicate (GetRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRoute_Response_& instance) = 0;

            protected:
                GetRoute_Response_DataReaderView () {};
                ~GetRoute_Response_DataReaderView () {};
            private:
                GetRoute_Response_DataReaderView (const GetRoute_Response_DataReaderView &);
                GetRoute_Response_DataReaderView & operator = (const GetRoute_Response_DataReaderView &);
            };
            class Sample_GetRoute_Request_TypeSupportInterface;

            typedef Sample_GetRoute_Request_TypeSupportInterface * Sample_GetRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Request_TypeSupportInterface> Sample_GetRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Request_TypeSupportInterface> Sample_GetRoute_Request_TypeSupportInterface_out;


            class Sample_GetRoute_Request_DataWriter;

            typedef Sample_GetRoute_Request_DataWriter * Sample_GetRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Request_DataWriter> Sample_GetRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Request_DataWriter> Sample_GetRoute_Request_DataWriter_out;


            class Sample_GetRoute_Request_DataReader;

            typedef Sample_GetRoute_Request_DataReader * Sample_GetRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Request_DataReader> Sample_GetRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Request_DataReader> Sample_GetRoute_Request_DataReader_out;


            class Sample_GetRoute_Request_DataReaderView;

            typedef Sample_GetRoute_Request_DataReaderView * Sample_GetRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Request_DataReaderView> Sample_GetRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Request_DataReaderView> Sample_GetRoute_Request_DataReaderView_out;

            struct Sample_GetRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetRoute_Request_, struct Sample_GetRoute_Request_Seq_uniq_> Sample_GetRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetRoute_Request_Seq> Sample_GetRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetRoute_Request_Seq> Sample_GetRoute_Request_Seq_out;

            class  Sample_GetRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetRoute_Request_TypeSupportInterface_var _var_type;

                static Sample_GetRoute_Request_TypeSupportInterface_ptr _duplicate (Sample_GetRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetRoute_Request_TypeSupportInterface () {};
                ~Sample_GetRoute_Request_TypeSupportInterface () {};
            private:
                Sample_GetRoute_Request_TypeSupportInterface (const Sample_GetRoute_Request_TypeSupportInterface &);
                Sample_GetRoute_Request_TypeSupportInterface & operator = (const Sample_GetRoute_Request_TypeSupportInterface &);
            };

            class  Sample_GetRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetRoute_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetRoute_Request_DataWriter_var _var_type;

                static Sample_GetRoute_Request_DataWriter_ptr _duplicate (Sample_GetRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoute_Request_& instance_data) = 0;

            protected:
                Sample_GetRoute_Request_DataWriter () {};
                ~Sample_GetRoute_Request_DataWriter () {};
            private:
                Sample_GetRoute_Request_DataWriter (const Sample_GetRoute_Request_DataWriter &);
                Sample_GetRoute_Request_DataWriter & operator = (const Sample_GetRoute_Request_DataWriter &);
            };

            class  Sample_GetRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetRoute_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetRoute_Request_DataReader_var _var_type;

                static Sample_GetRoute_Request_DataReader_ptr _duplicate (Sample_GetRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoute_Request_& instance) = 0;

            protected:
                Sample_GetRoute_Request_DataReader () {};
                ~Sample_GetRoute_Request_DataReader () {};
            private:
                Sample_GetRoute_Request_DataReader (const Sample_GetRoute_Request_DataReader &);
                Sample_GetRoute_Request_DataReader & operator = (const Sample_GetRoute_Request_DataReader &);
            };

            class  Sample_GetRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetRoute_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetRoute_Request_DataReaderView_var _var_type;

                static Sample_GetRoute_Request_DataReaderView_ptr _duplicate (Sample_GetRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoute_Request_& instance) = 0;

            protected:
                Sample_GetRoute_Request_DataReaderView () {};
                ~Sample_GetRoute_Request_DataReaderView () {};
            private:
                Sample_GetRoute_Request_DataReaderView (const Sample_GetRoute_Request_DataReaderView &);
                Sample_GetRoute_Request_DataReaderView & operator = (const Sample_GetRoute_Request_DataReaderView &);
            };
            class Sample_GetRoute_Response_TypeSupportInterface;

            typedef Sample_GetRoute_Response_TypeSupportInterface * Sample_GetRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Response_TypeSupportInterface> Sample_GetRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Response_TypeSupportInterface> Sample_GetRoute_Response_TypeSupportInterface_out;


            class Sample_GetRoute_Response_DataWriter;

            typedef Sample_GetRoute_Response_DataWriter * Sample_GetRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Response_DataWriter> Sample_GetRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Response_DataWriter> Sample_GetRoute_Response_DataWriter_out;


            class Sample_GetRoute_Response_DataReader;

            typedef Sample_GetRoute_Response_DataReader * Sample_GetRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Response_DataReader> Sample_GetRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Response_DataReader> Sample_GetRoute_Response_DataReader_out;


            class Sample_GetRoute_Response_DataReaderView;

            typedef Sample_GetRoute_Response_DataReaderView * Sample_GetRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRoute_Response_DataReaderView> Sample_GetRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetRoute_Response_DataReaderView> Sample_GetRoute_Response_DataReaderView_out;

            struct Sample_GetRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetRoute_Response_, struct Sample_GetRoute_Response_Seq_uniq_> Sample_GetRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetRoute_Response_Seq> Sample_GetRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetRoute_Response_Seq> Sample_GetRoute_Response_Seq_out;

            class  Sample_GetRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetRoute_Response_TypeSupportInterface_var _var_type;

                static Sample_GetRoute_Response_TypeSupportInterface_ptr _duplicate (Sample_GetRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetRoute_Response_TypeSupportInterface () {};
                ~Sample_GetRoute_Response_TypeSupportInterface () {};
            private:
                Sample_GetRoute_Response_TypeSupportInterface (const Sample_GetRoute_Response_TypeSupportInterface &);
                Sample_GetRoute_Response_TypeSupportInterface & operator = (const Sample_GetRoute_Response_TypeSupportInterface &);
            };

            class  Sample_GetRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetRoute_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetRoute_Response_DataWriter_var _var_type;

                static Sample_GetRoute_Response_DataWriter_ptr _duplicate (Sample_GetRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoute_Response_& instance_data) = 0;

            protected:
                Sample_GetRoute_Response_DataWriter () {};
                ~Sample_GetRoute_Response_DataWriter () {};
            private:
                Sample_GetRoute_Response_DataWriter (const Sample_GetRoute_Response_DataWriter &);
                Sample_GetRoute_Response_DataWriter & operator = (const Sample_GetRoute_Response_DataWriter &);
            };

            class  Sample_GetRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetRoute_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetRoute_Response_DataReader_var _var_type;

                static Sample_GetRoute_Response_DataReader_ptr _duplicate (Sample_GetRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoute_Response_& instance) = 0;

            protected:
                Sample_GetRoute_Response_DataReader () {};
                ~Sample_GetRoute_Response_DataReader () {};
            private:
                Sample_GetRoute_Response_DataReader (const Sample_GetRoute_Response_DataReader &);
                Sample_GetRoute_Response_DataReader & operator = (const Sample_GetRoute_Response_DataReader &);
            };

            class  Sample_GetRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetRoute_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetRoute_Response_DataReaderView_var _var_type;

                static Sample_GetRoute_Response_DataReaderView_ptr _duplicate (Sample_GetRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRoute_Response_& instance) = 0;

            protected:
                Sample_GetRoute_Response_DataReaderView () {};
                ~Sample_GetRoute_Response_DataReaderView () {};
            private:
                Sample_GetRoute_Response_DataReaderView (const Sample_GetRoute_Response_DataReaderView &);
                Sample_GetRoute_Response_DataReaderView & operator = (const Sample_GetRoute_Response_DataReaderView &);
            };
        }

    }

}

#endif
