#ifndef _H_8A77F10C81851B305A7C81758A4AE2A6_PlanRoute_DCPS_H_
#define _H_8A77F10C81851B305A7C81758A4AE2A6_PlanRoute_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PlanRoute_.h"


namespace marti_nav_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class PlanRoute_Request_TypeSupportInterface;

            typedef PlanRoute_Request_TypeSupportInterface * PlanRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Request_TypeSupportInterface> PlanRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Request_TypeSupportInterface> PlanRoute_Request_TypeSupportInterface_out;


            class PlanRoute_Request_DataWriter;

            typedef PlanRoute_Request_DataWriter * PlanRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Request_DataWriter> PlanRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Request_DataWriter> PlanRoute_Request_DataWriter_out;


            class PlanRoute_Request_DataReader;

            typedef PlanRoute_Request_DataReader * PlanRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Request_DataReader> PlanRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Request_DataReader> PlanRoute_Request_DataReader_out;


            class PlanRoute_Request_DataReaderView;

            typedef PlanRoute_Request_DataReaderView * PlanRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Request_DataReaderView> PlanRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Request_DataReaderView> PlanRoute_Request_DataReaderView_out;

            struct PlanRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PlanRoute_Request_, struct PlanRoute_Request_Seq_uniq_> PlanRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < PlanRoute_Request_Seq> PlanRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < PlanRoute_Request_Seq> PlanRoute_Request_Seq_out;

            class  PlanRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PlanRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef PlanRoute_Request_TypeSupportInterface_var _var_type;

                static PlanRoute_Request_TypeSupportInterface_ptr _duplicate (PlanRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PlanRoute_Request_TypeSupportInterface () {};
                ~PlanRoute_Request_TypeSupportInterface () {};
            private:
                PlanRoute_Request_TypeSupportInterface (const PlanRoute_Request_TypeSupportInterface &);
                PlanRoute_Request_TypeSupportInterface & operator = (const PlanRoute_Request_TypeSupportInterface &);
            };

            class  PlanRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PlanRoute_Request_DataWriter_ptr _ptr_type;
                typedef PlanRoute_Request_DataWriter_var _var_type;

                static PlanRoute_Request_DataWriter_ptr _duplicate (PlanRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PlanRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PlanRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PlanRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PlanRoute_Request_& instance_data) = 0;

            protected:
                PlanRoute_Request_DataWriter () {};
                ~PlanRoute_Request_DataWriter () {};
            private:
                PlanRoute_Request_DataWriter (const PlanRoute_Request_DataWriter &);
                PlanRoute_Request_DataWriter & operator = (const PlanRoute_Request_DataWriter &);
            };

            class  PlanRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PlanRoute_Request_DataReader_ptr _ptr_type;
                typedef PlanRoute_Request_DataReader_var _var_type;

                static PlanRoute_Request_DataReader_ptr _duplicate (PlanRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PlanRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PlanRoute_Request_& instance) = 0;

            protected:
                PlanRoute_Request_DataReader () {};
                ~PlanRoute_Request_DataReader () {};
            private:
                PlanRoute_Request_DataReader (const PlanRoute_Request_DataReader &);
                PlanRoute_Request_DataReader & operator = (const PlanRoute_Request_DataReader &);
            };

            class  PlanRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PlanRoute_Request_DataReaderView_ptr _ptr_type;
                typedef PlanRoute_Request_DataReaderView_var _var_type;

                static PlanRoute_Request_DataReaderView_ptr _duplicate (PlanRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PlanRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PlanRoute_Request_& instance) = 0;

            protected:
                PlanRoute_Request_DataReaderView () {};
                ~PlanRoute_Request_DataReaderView () {};
            private:
                PlanRoute_Request_DataReaderView (const PlanRoute_Request_DataReaderView &);
                PlanRoute_Request_DataReaderView & operator = (const PlanRoute_Request_DataReaderView &);
            };
            class PlanRoute_Response_TypeSupportInterface;

            typedef PlanRoute_Response_TypeSupportInterface * PlanRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Response_TypeSupportInterface> PlanRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Response_TypeSupportInterface> PlanRoute_Response_TypeSupportInterface_out;


            class PlanRoute_Response_DataWriter;

            typedef PlanRoute_Response_DataWriter * PlanRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Response_DataWriter> PlanRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Response_DataWriter> PlanRoute_Response_DataWriter_out;


            class PlanRoute_Response_DataReader;

            typedef PlanRoute_Response_DataReader * PlanRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Response_DataReader> PlanRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Response_DataReader> PlanRoute_Response_DataReader_out;


            class PlanRoute_Response_DataReaderView;

            typedef PlanRoute_Response_DataReaderView * PlanRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PlanRoute_Response_DataReaderView> PlanRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PlanRoute_Response_DataReaderView> PlanRoute_Response_DataReaderView_out;

            struct PlanRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PlanRoute_Response_, struct PlanRoute_Response_Seq_uniq_> PlanRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < PlanRoute_Response_Seq> PlanRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < PlanRoute_Response_Seq> PlanRoute_Response_Seq_out;

            class  PlanRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PlanRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef PlanRoute_Response_TypeSupportInterface_var _var_type;

                static PlanRoute_Response_TypeSupportInterface_ptr _duplicate (PlanRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PlanRoute_Response_TypeSupportInterface () {};
                ~PlanRoute_Response_TypeSupportInterface () {};
            private:
                PlanRoute_Response_TypeSupportInterface (const PlanRoute_Response_TypeSupportInterface &);
                PlanRoute_Response_TypeSupportInterface & operator = (const PlanRoute_Response_TypeSupportInterface &);
            };

            class  PlanRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PlanRoute_Response_DataWriter_ptr _ptr_type;
                typedef PlanRoute_Response_DataWriter_var _var_type;

                static PlanRoute_Response_DataWriter_ptr _duplicate (PlanRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PlanRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PlanRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PlanRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PlanRoute_Response_& instance_data) = 0;

            protected:
                PlanRoute_Response_DataWriter () {};
                ~PlanRoute_Response_DataWriter () {};
            private:
                PlanRoute_Response_DataWriter (const PlanRoute_Response_DataWriter &);
                PlanRoute_Response_DataWriter & operator = (const PlanRoute_Response_DataWriter &);
            };

            class  PlanRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PlanRoute_Response_DataReader_ptr _ptr_type;
                typedef PlanRoute_Response_DataReader_var _var_type;

                static PlanRoute_Response_DataReader_ptr _duplicate (PlanRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PlanRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PlanRoute_Response_& instance) = 0;

            protected:
                PlanRoute_Response_DataReader () {};
                ~PlanRoute_Response_DataReader () {};
            private:
                PlanRoute_Response_DataReader (const PlanRoute_Response_DataReader &);
                PlanRoute_Response_DataReader & operator = (const PlanRoute_Response_DataReader &);
            };

            class  PlanRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PlanRoute_Response_DataReaderView_ptr _ptr_type;
                typedef PlanRoute_Response_DataReaderView_var _var_type;

                static PlanRoute_Response_DataReaderView_ptr _duplicate (PlanRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PlanRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PlanRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PlanRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PlanRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PlanRoute_Response_& instance) = 0;

            protected:
                PlanRoute_Response_DataReaderView () {};
                ~PlanRoute_Response_DataReaderView () {};
            private:
                PlanRoute_Response_DataReaderView (const PlanRoute_Response_DataReaderView &);
                PlanRoute_Response_DataReaderView & operator = (const PlanRoute_Response_DataReaderView &);
            };
            class Sample_PlanRoute_Request_TypeSupportInterface;

            typedef Sample_PlanRoute_Request_TypeSupportInterface * Sample_PlanRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Request_TypeSupportInterface> Sample_PlanRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Request_TypeSupportInterface> Sample_PlanRoute_Request_TypeSupportInterface_out;


            class Sample_PlanRoute_Request_DataWriter;

            typedef Sample_PlanRoute_Request_DataWriter * Sample_PlanRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Request_DataWriter> Sample_PlanRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Request_DataWriter> Sample_PlanRoute_Request_DataWriter_out;


            class Sample_PlanRoute_Request_DataReader;

            typedef Sample_PlanRoute_Request_DataReader * Sample_PlanRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Request_DataReader> Sample_PlanRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Request_DataReader> Sample_PlanRoute_Request_DataReader_out;


            class Sample_PlanRoute_Request_DataReaderView;

            typedef Sample_PlanRoute_Request_DataReaderView * Sample_PlanRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Request_DataReaderView> Sample_PlanRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Request_DataReaderView> Sample_PlanRoute_Request_DataReaderView_out;

            struct Sample_PlanRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_PlanRoute_Request_, struct Sample_PlanRoute_Request_Seq_uniq_> Sample_PlanRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_PlanRoute_Request_Seq> Sample_PlanRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_PlanRoute_Request_Seq> Sample_PlanRoute_Request_Seq_out;

            class  Sample_PlanRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_PlanRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_PlanRoute_Request_TypeSupportInterface_var _var_type;

                static Sample_PlanRoute_Request_TypeSupportInterface_ptr _duplicate (Sample_PlanRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_PlanRoute_Request_TypeSupportInterface () {};
                ~Sample_PlanRoute_Request_TypeSupportInterface () {};
            private:
                Sample_PlanRoute_Request_TypeSupportInterface (const Sample_PlanRoute_Request_TypeSupportInterface &);
                Sample_PlanRoute_Request_TypeSupportInterface & operator = (const Sample_PlanRoute_Request_TypeSupportInterface &);
            };

            class  Sample_PlanRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_PlanRoute_Request_DataWriter_ptr _ptr_type;
                typedef Sample_PlanRoute_Request_DataWriter_var _var_type;

                static Sample_PlanRoute_Request_DataWriter_ptr _duplicate (Sample_PlanRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_PlanRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_PlanRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_PlanRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_PlanRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PlanRoute_Request_& instance_data) = 0;

            protected:
                Sample_PlanRoute_Request_DataWriter () {};
                ~Sample_PlanRoute_Request_DataWriter () {};
            private:
                Sample_PlanRoute_Request_DataWriter (const Sample_PlanRoute_Request_DataWriter &);
                Sample_PlanRoute_Request_DataWriter & operator = (const Sample_PlanRoute_Request_DataWriter &);
            };

            class  Sample_PlanRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_PlanRoute_Request_DataReader_ptr _ptr_type;
                typedef Sample_PlanRoute_Request_DataReader_var _var_type;

                static Sample_PlanRoute_Request_DataReader_ptr _duplicate (Sample_PlanRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PlanRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PlanRoute_Request_& instance) = 0;

            protected:
                Sample_PlanRoute_Request_DataReader () {};
                ~Sample_PlanRoute_Request_DataReader () {};
            private:
                Sample_PlanRoute_Request_DataReader (const Sample_PlanRoute_Request_DataReader &);
                Sample_PlanRoute_Request_DataReader & operator = (const Sample_PlanRoute_Request_DataReader &);
            };

            class  Sample_PlanRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_PlanRoute_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_PlanRoute_Request_DataReaderView_var _var_type;

                static Sample_PlanRoute_Request_DataReaderView_ptr _duplicate (Sample_PlanRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PlanRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PlanRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PlanRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PlanRoute_Request_& instance) = 0;

            protected:
                Sample_PlanRoute_Request_DataReaderView () {};
                ~Sample_PlanRoute_Request_DataReaderView () {};
            private:
                Sample_PlanRoute_Request_DataReaderView (const Sample_PlanRoute_Request_DataReaderView &);
                Sample_PlanRoute_Request_DataReaderView & operator = (const Sample_PlanRoute_Request_DataReaderView &);
            };
            class Sample_PlanRoute_Response_TypeSupportInterface;

            typedef Sample_PlanRoute_Response_TypeSupportInterface * Sample_PlanRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Response_TypeSupportInterface> Sample_PlanRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Response_TypeSupportInterface> Sample_PlanRoute_Response_TypeSupportInterface_out;


            class Sample_PlanRoute_Response_DataWriter;

            typedef Sample_PlanRoute_Response_DataWriter * Sample_PlanRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Response_DataWriter> Sample_PlanRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Response_DataWriter> Sample_PlanRoute_Response_DataWriter_out;


            class Sample_PlanRoute_Response_DataReader;

            typedef Sample_PlanRoute_Response_DataReader * Sample_PlanRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Response_DataReader> Sample_PlanRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Response_DataReader> Sample_PlanRoute_Response_DataReader_out;


            class Sample_PlanRoute_Response_DataReaderView;

            typedef Sample_PlanRoute_Response_DataReaderView * Sample_PlanRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_PlanRoute_Response_DataReaderView> Sample_PlanRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_PlanRoute_Response_DataReaderView> Sample_PlanRoute_Response_DataReaderView_out;

            struct Sample_PlanRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_PlanRoute_Response_, struct Sample_PlanRoute_Response_Seq_uniq_> Sample_PlanRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_PlanRoute_Response_Seq> Sample_PlanRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_PlanRoute_Response_Seq> Sample_PlanRoute_Response_Seq_out;

            class  Sample_PlanRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_PlanRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_PlanRoute_Response_TypeSupportInterface_var _var_type;

                static Sample_PlanRoute_Response_TypeSupportInterface_ptr _duplicate (Sample_PlanRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_PlanRoute_Response_TypeSupportInterface () {};
                ~Sample_PlanRoute_Response_TypeSupportInterface () {};
            private:
                Sample_PlanRoute_Response_TypeSupportInterface (const Sample_PlanRoute_Response_TypeSupportInterface &);
                Sample_PlanRoute_Response_TypeSupportInterface & operator = (const Sample_PlanRoute_Response_TypeSupportInterface &);
            };

            class  Sample_PlanRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_PlanRoute_Response_DataWriter_ptr _ptr_type;
                typedef Sample_PlanRoute_Response_DataWriter_var _var_type;

                static Sample_PlanRoute_Response_DataWriter_ptr _duplicate (Sample_PlanRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_PlanRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_PlanRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_PlanRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_PlanRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PlanRoute_Response_& instance_data) = 0;

            protected:
                Sample_PlanRoute_Response_DataWriter () {};
                ~Sample_PlanRoute_Response_DataWriter () {};
            private:
                Sample_PlanRoute_Response_DataWriter (const Sample_PlanRoute_Response_DataWriter &);
                Sample_PlanRoute_Response_DataWriter & operator = (const Sample_PlanRoute_Response_DataWriter &);
            };

            class  Sample_PlanRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_PlanRoute_Response_DataReader_ptr _ptr_type;
                typedef Sample_PlanRoute_Response_DataReader_var _var_type;

                static Sample_PlanRoute_Response_DataReader_ptr _duplicate (Sample_PlanRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PlanRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PlanRoute_Response_& instance) = 0;

            protected:
                Sample_PlanRoute_Response_DataReader () {};
                ~Sample_PlanRoute_Response_DataReader () {};
            private:
                Sample_PlanRoute_Response_DataReader (const Sample_PlanRoute_Response_DataReader &);
                Sample_PlanRoute_Response_DataReader & operator = (const Sample_PlanRoute_Response_DataReader &);
            };

            class  Sample_PlanRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_PlanRoute_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_PlanRoute_Response_DataReaderView_var _var_type;

                static Sample_PlanRoute_Response_DataReaderView_ptr _duplicate (Sample_PlanRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PlanRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PlanRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PlanRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PlanRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PlanRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PlanRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PlanRoute_Response_& instance) = 0;

            protected:
                Sample_PlanRoute_Response_DataReaderView () {};
                ~Sample_PlanRoute_Response_DataReaderView () {};
            private:
                Sample_PlanRoute_Response_DataReaderView (const Sample_PlanRoute_Response_DataReaderView &);
                Sample_PlanRoute_Response_DataReaderView & operator = (const Sample_PlanRoute_Response_DataReaderView &);
            };
        }

    }

}

#endif
