#ifndef H_8A77F10C81851B305A7C81758A4AE2A6_PlanRoute_SPLTYPES_H
#define H_8A77F10C81851B305A7C81758A4AE2A6_PlanRoute_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_PlanRoute_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_SplDcps.h"
#include "marti_nav_msgs/msg/dds_opensplice/Route_SplDcps.h"



extern c_metaObject __PlanRoute__marti_nav_msgs__load (c_base base);

extern c_metaObject __PlanRoute__marti_nav_msgs_srv__load (c_base base);

extern c_metaObject __PlanRoute__marti_nav_msgs_srv_dds___load (c_base base);

extern const char *marti_nav_msgs_srv_dds__PlanRoute_Request__metaDescriptor[];
extern const int marti_nav_msgs_srv_dds__PlanRoute_Request__metaDescriptorArrLength;
extern const int marti_nav_msgs_srv_dds__PlanRoute_Request__metaDescriptorLength;
extern c_metaObject __marti_nav_msgs_srv_dds__PlanRoute_Request___load (c_base base);
struct _marti_nav_msgs_srv_dds__PlanRoute_Request_ ;
extern  v_copyin_result __marti_nav_msgs_srv_dds__PlanRoute_Request___copyIn(c_base base, const struct marti_nav_msgs::srv::dds_::PlanRoute_Request_ *from, struct _marti_nav_msgs_srv_dds__PlanRoute_Request_ *to);
extern  void __marti_nav_msgs_srv_dds__PlanRoute_Request___copyOut(const void *_from, void *_to);
struct _marti_nav_msgs_srv_dds__PlanRoute_Request_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_sequence waypoints_;
    c_bool plan_from_vehicle_;
};

extern const char *marti_nav_msgs_srv_dds__PlanRoute_Response__metaDescriptor[];
extern const int marti_nav_msgs_srv_dds__PlanRoute_Response__metaDescriptorArrLength;
extern const int marti_nav_msgs_srv_dds__PlanRoute_Response__metaDescriptorLength;
extern c_metaObject __marti_nav_msgs_srv_dds__PlanRoute_Response___load (c_base base);
struct _marti_nav_msgs_srv_dds__PlanRoute_Response_ ;
extern  v_copyin_result __marti_nav_msgs_srv_dds__PlanRoute_Response___copyIn(c_base base, const struct marti_nav_msgs::srv::dds_::PlanRoute_Response_ *from, struct _marti_nav_msgs_srv_dds__PlanRoute_Response_ *to);
extern  void __marti_nav_msgs_srv_dds__PlanRoute_Response___copyOut(const void *_from, void *_to);
struct _marti_nav_msgs_srv_dds__PlanRoute_Response_ {
    struct _marti_nav_msgs_msg_dds__Route_ route_;
    c_bool success_;
    c_string message_;
};

extern const char *marti_nav_msgs_srv_dds__Sample_PlanRoute_Request__metaDescriptor[];
extern const int marti_nav_msgs_srv_dds__Sample_PlanRoute_Request__metaDescriptorArrLength;
extern const int marti_nav_msgs_srv_dds__Sample_PlanRoute_Request__metaDescriptorLength;
extern c_metaObject __marti_nav_msgs_srv_dds__Sample_PlanRoute_Request___load (c_base base);
struct _marti_nav_msgs_srv_dds__Sample_PlanRoute_Request_ ;
extern  v_copyin_result __marti_nav_msgs_srv_dds__Sample_PlanRoute_Request___copyIn(c_base base, const struct marti_nav_msgs::srv::dds_::Sample_PlanRoute_Request_ *from, struct _marti_nav_msgs_srv_dds__Sample_PlanRoute_Request_ *to);
extern  void __marti_nav_msgs_srv_dds__Sample_PlanRoute_Request___copyOut(const void *_from, void *_to);
struct _marti_nav_msgs_srv_dds__Sample_PlanRoute_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _marti_nav_msgs_srv_dds__PlanRoute_Request_ request_;
};

extern const char *marti_nav_msgs_srv_dds__Sample_PlanRoute_Response__metaDescriptor[];
extern const int marti_nav_msgs_srv_dds__Sample_PlanRoute_Response__metaDescriptorArrLength;
extern const int marti_nav_msgs_srv_dds__Sample_PlanRoute_Response__metaDescriptorLength;
extern c_metaObject __marti_nav_msgs_srv_dds__Sample_PlanRoute_Response___load (c_base base);
struct _marti_nav_msgs_srv_dds__Sample_PlanRoute_Response_ ;
extern  v_copyin_result __marti_nav_msgs_srv_dds__Sample_PlanRoute_Response___copyIn(c_base base, const struct marti_nav_msgs::srv::dds_::Sample_PlanRoute_Response_ *from, struct _marti_nav_msgs_srv_dds__Sample_PlanRoute_Response_ *to);
extern  void __marti_nav_msgs_srv_dds__Sample_PlanRoute_Response___copyOut(const void *_from, void *_to);
struct _marti_nav_msgs_srv_dds__Sample_PlanRoute_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _marti_nav_msgs_srv_dds__PlanRoute_Response_ response_;
};

#undef OS_API
#endif
