#ifndef _H_F14A49C7E8ECAE5FC4F52BAF67675707_SaveRecordedRoute_DCPS_H_
#define _H_F14A49C7E8ECAE5FC4F52BAF67675707_SaveRecordedRoute_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SaveRecordedRoute_.h"


namespace marti_nav_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SaveRecordedRoute_Request_TypeSupportInterface;

            typedef SaveRecordedRoute_Request_TypeSupportInterface * SaveRecordedRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Request_TypeSupportInterface> SaveRecordedRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Request_TypeSupportInterface> SaveRecordedRoute_Request_TypeSupportInterface_out;


            class SaveRecordedRoute_Request_DataWriter;

            typedef SaveRecordedRoute_Request_DataWriter * SaveRecordedRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Request_DataWriter> SaveRecordedRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Request_DataWriter> SaveRecordedRoute_Request_DataWriter_out;


            class SaveRecordedRoute_Request_DataReader;

            typedef SaveRecordedRoute_Request_DataReader * SaveRecordedRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Request_DataReader> SaveRecordedRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Request_DataReader> SaveRecordedRoute_Request_DataReader_out;


            class SaveRecordedRoute_Request_DataReaderView;

            typedef SaveRecordedRoute_Request_DataReaderView * SaveRecordedRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Request_DataReaderView> SaveRecordedRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Request_DataReaderView> SaveRecordedRoute_Request_DataReaderView_out;

            struct SaveRecordedRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SaveRecordedRoute_Request_, struct SaveRecordedRoute_Request_Seq_uniq_> SaveRecordedRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < SaveRecordedRoute_Request_Seq> SaveRecordedRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SaveRecordedRoute_Request_Seq> SaveRecordedRoute_Request_Seq_out;

            class  SaveRecordedRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SaveRecordedRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SaveRecordedRoute_Request_TypeSupportInterface_var _var_type;

                static SaveRecordedRoute_Request_TypeSupportInterface_ptr _duplicate (SaveRecordedRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SaveRecordedRoute_Request_TypeSupportInterface () {};
                ~SaveRecordedRoute_Request_TypeSupportInterface () {};
            private:
                SaveRecordedRoute_Request_TypeSupportInterface (const SaveRecordedRoute_Request_TypeSupportInterface &);
                SaveRecordedRoute_Request_TypeSupportInterface & operator = (const SaveRecordedRoute_Request_TypeSupportInterface &);
            };

            class  SaveRecordedRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SaveRecordedRoute_Request_DataWriter_ptr _ptr_type;
                typedef SaveRecordedRoute_Request_DataWriter_var _var_type;

                static SaveRecordedRoute_Request_DataWriter_ptr _duplicate (SaveRecordedRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SaveRecordedRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SaveRecordedRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SaveRecordedRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveRecordedRoute_Request_& instance_data) = 0;

            protected:
                SaveRecordedRoute_Request_DataWriter () {};
                ~SaveRecordedRoute_Request_DataWriter () {};
            private:
                SaveRecordedRoute_Request_DataWriter (const SaveRecordedRoute_Request_DataWriter &);
                SaveRecordedRoute_Request_DataWriter & operator = (const SaveRecordedRoute_Request_DataWriter &);
            };

            class  SaveRecordedRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SaveRecordedRoute_Request_DataReader_ptr _ptr_type;
                typedef SaveRecordedRoute_Request_DataReader_var _var_type;

                static SaveRecordedRoute_Request_DataReader_ptr _duplicate (SaveRecordedRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SaveRecordedRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveRecordedRoute_Request_& instance) = 0;

            protected:
                SaveRecordedRoute_Request_DataReader () {};
                ~SaveRecordedRoute_Request_DataReader () {};
            private:
                SaveRecordedRoute_Request_DataReader (const SaveRecordedRoute_Request_DataReader &);
                SaveRecordedRoute_Request_DataReader & operator = (const SaveRecordedRoute_Request_DataReader &);
            };

            class  SaveRecordedRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SaveRecordedRoute_Request_DataReaderView_ptr _ptr_type;
                typedef SaveRecordedRoute_Request_DataReaderView_var _var_type;

                static SaveRecordedRoute_Request_DataReaderView_ptr _duplicate (SaveRecordedRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SaveRecordedRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveRecordedRoute_Request_& instance) = 0;

            protected:
                SaveRecordedRoute_Request_DataReaderView () {};
                ~SaveRecordedRoute_Request_DataReaderView () {};
            private:
                SaveRecordedRoute_Request_DataReaderView (const SaveRecordedRoute_Request_DataReaderView &);
                SaveRecordedRoute_Request_DataReaderView & operator = (const SaveRecordedRoute_Request_DataReaderView &);
            };
            class SaveRecordedRoute_Response_TypeSupportInterface;

            typedef SaveRecordedRoute_Response_TypeSupportInterface * SaveRecordedRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Response_TypeSupportInterface> SaveRecordedRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Response_TypeSupportInterface> SaveRecordedRoute_Response_TypeSupportInterface_out;


            class SaveRecordedRoute_Response_DataWriter;

            typedef SaveRecordedRoute_Response_DataWriter * SaveRecordedRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Response_DataWriter> SaveRecordedRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Response_DataWriter> SaveRecordedRoute_Response_DataWriter_out;


            class SaveRecordedRoute_Response_DataReader;

            typedef SaveRecordedRoute_Response_DataReader * SaveRecordedRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Response_DataReader> SaveRecordedRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Response_DataReader> SaveRecordedRoute_Response_DataReader_out;


            class SaveRecordedRoute_Response_DataReaderView;

            typedef SaveRecordedRoute_Response_DataReaderView * SaveRecordedRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SaveRecordedRoute_Response_DataReaderView> SaveRecordedRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SaveRecordedRoute_Response_DataReaderView> SaveRecordedRoute_Response_DataReaderView_out;

            struct SaveRecordedRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SaveRecordedRoute_Response_, struct SaveRecordedRoute_Response_Seq_uniq_> SaveRecordedRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < SaveRecordedRoute_Response_Seq> SaveRecordedRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SaveRecordedRoute_Response_Seq> SaveRecordedRoute_Response_Seq_out;

            class  SaveRecordedRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SaveRecordedRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SaveRecordedRoute_Response_TypeSupportInterface_var _var_type;

                static SaveRecordedRoute_Response_TypeSupportInterface_ptr _duplicate (SaveRecordedRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SaveRecordedRoute_Response_TypeSupportInterface () {};
                ~SaveRecordedRoute_Response_TypeSupportInterface () {};
            private:
                SaveRecordedRoute_Response_TypeSupportInterface (const SaveRecordedRoute_Response_TypeSupportInterface &);
                SaveRecordedRoute_Response_TypeSupportInterface & operator = (const SaveRecordedRoute_Response_TypeSupportInterface &);
            };

            class  SaveRecordedRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SaveRecordedRoute_Response_DataWriter_ptr _ptr_type;
                typedef SaveRecordedRoute_Response_DataWriter_var _var_type;

                static SaveRecordedRoute_Response_DataWriter_ptr _duplicate (SaveRecordedRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SaveRecordedRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SaveRecordedRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SaveRecordedRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveRecordedRoute_Response_& instance_data) = 0;

            protected:
                SaveRecordedRoute_Response_DataWriter () {};
                ~SaveRecordedRoute_Response_DataWriter () {};
            private:
                SaveRecordedRoute_Response_DataWriter (const SaveRecordedRoute_Response_DataWriter &);
                SaveRecordedRoute_Response_DataWriter & operator = (const SaveRecordedRoute_Response_DataWriter &);
            };

            class  SaveRecordedRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SaveRecordedRoute_Response_DataReader_ptr _ptr_type;
                typedef SaveRecordedRoute_Response_DataReader_var _var_type;

                static SaveRecordedRoute_Response_DataReader_ptr _duplicate (SaveRecordedRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SaveRecordedRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveRecordedRoute_Response_& instance) = 0;

            protected:
                SaveRecordedRoute_Response_DataReader () {};
                ~SaveRecordedRoute_Response_DataReader () {};
            private:
                SaveRecordedRoute_Response_DataReader (const SaveRecordedRoute_Response_DataReader &);
                SaveRecordedRoute_Response_DataReader & operator = (const SaveRecordedRoute_Response_DataReader &);
            };

            class  SaveRecordedRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SaveRecordedRoute_Response_DataReaderView_ptr _ptr_type;
                typedef SaveRecordedRoute_Response_DataReaderView_var _var_type;

                static SaveRecordedRoute_Response_DataReaderView_ptr _duplicate (SaveRecordedRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveRecordedRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveRecordedRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveRecordedRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SaveRecordedRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveRecordedRoute_Response_& instance) = 0;

            protected:
                SaveRecordedRoute_Response_DataReaderView () {};
                ~SaveRecordedRoute_Response_DataReaderView () {};
            private:
                SaveRecordedRoute_Response_DataReaderView (const SaveRecordedRoute_Response_DataReaderView &);
                SaveRecordedRoute_Response_DataReaderView & operator = (const SaveRecordedRoute_Response_DataReaderView &);
            };
            class Sample_SaveRecordedRoute_Request_TypeSupportInterface;

            typedef Sample_SaveRecordedRoute_Request_TypeSupportInterface * Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Request_TypeSupportInterface> Sample_SaveRecordedRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Request_TypeSupportInterface> Sample_SaveRecordedRoute_Request_TypeSupportInterface_out;


            class Sample_SaveRecordedRoute_Request_DataWriter;

            typedef Sample_SaveRecordedRoute_Request_DataWriter * Sample_SaveRecordedRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Request_DataWriter> Sample_SaveRecordedRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Request_DataWriter> Sample_SaveRecordedRoute_Request_DataWriter_out;


            class Sample_SaveRecordedRoute_Request_DataReader;

            typedef Sample_SaveRecordedRoute_Request_DataReader * Sample_SaveRecordedRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Request_DataReader> Sample_SaveRecordedRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Request_DataReader> Sample_SaveRecordedRoute_Request_DataReader_out;


            class Sample_SaveRecordedRoute_Request_DataReaderView;

            typedef Sample_SaveRecordedRoute_Request_DataReaderView * Sample_SaveRecordedRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Request_DataReaderView> Sample_SaveRecordedRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Request_DataReaderView> Sample_SaveRecordedRoute_Request_DataReaderView_out;

            struct Sample_SaveRecordedRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SaveRecordedRoute_Request_, struct Sample_SaveRecordedRoute_Request_Seq_uniq_> Sample_SaveRecordedRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SaveRecordedRoute_Request_Seq> Sample_SaveRecordedRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SaveRecordedRoute_Request_Seq> Sample_SaveRecordedRoute_Request_Seq_out;

            class  Sample_SaveRecordedRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Request_TypeSupportInterface_var _var_type;

                static Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr _duplicate (Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SaveRecordedRoute_Request_TypeSupportInterface () {};
                ~Sample_SaveRecordedRoute_Request_TypeSupportInterface () {};
            private:
                Sample_SaveRecordedRoute_Request_TypeSupportInterface (const Sample_SaveRecordedRoute_Request_TypeSupportInterface &);
                Sample_SaveRecordedRoute_Request_TypeSupportInterface & operator = (const Sample_SaveRecordedRoute_Request_TypeSupportInterface &);
            };

            class  Sample_SaveRecordedRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SaveRecordedRoute_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Request_DataWriter_var _var_type;

                static Sample_SaveRecordedRoute_Request_DataWriter_ptr _duplicate (Sample_SaveRecordedRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SaveRecordedRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SaveRecordedRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SaveRecordedRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SaveRecordedRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SaveRecordedRoute_Request_& instance_data) = 0;

            protected:
                Sample_SaveRecordedRoute_Request_DataWriter () {};
                ~Sample_SaveRecordedRoute_Request_DataWriter () {};
            private:
                Sample_SaveRecordedRoute_Request_DataWriter (const Sample_SaveRecordedRoute_Request_DataWriter &);
                Sample_SaveRecordedRoute_Request_DataWriter & operator = (const Sample_SaveRecordedRoute_Request_DataWriter &);
            };

            class  Sample_SaveRecordedRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SaveRecordedRoute_Request_DataReader_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Request_DataReader_var _var_type;

                static Sample_SaveRecordedRoute_Request_DataReader_ptr _duplicate (Sample_SaveRecordedRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SaveRecordedRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SaveRecordedRoute_Request_& instance) = 0;

            protected:
                Sample_SaveRecordedRoute_Request_DataReader () {};
                ~Sample_SaveRecordedRoute_Request_DataReader () {};
            private:
                Sample_SaveRecordedRoute_Request_DataReader (const Sample_SaveRecordedRoute_Request_DataReader &);
                Sample_SaveRecordedRoute_Request_DataReader & operator = (const Sample_SaveRecordedRoute_Request_DataReader &);
            };

            class  Sample_SaveRecordedRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SaveRecordedRoute_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Request_DataReaderView_var _var_type;

                static Sample_SaveRecordedRoute_Request_DataReaderView_ptr _duplicate (Sample_SaveRecordedRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SaveRecordedRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SaveRecordedRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SaveRecordedRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SaveRecordedRoute_Request_& instance) = 0;

            protected:
                Sample_SaveRecordedRoute_Request_DataReaderView () {};
                ~Sample_SaveRecordedRoute_Request_DataReaderView () {};
            private:
                Sample_SaveRecordedRoute_Request_DataReaderView (const Sample_SaveRecordedRoute_Request_DataReaderView &);
                Sample_SaveRecordedRoute_Request_DataReaderView & operator = (const Sample_SaveRecordedRoute_Request_DataReaderView &);
            };
            class Sample_SaveRecordedRoute_Response_TypeSupportInterface;

            typedef Sample_SaveRecordedRoute_Response_TypeSupportInterface * Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Response_TypeSupportInterface> Sample_SaveRecordedRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Response_TypeSupportInterface> Sample_SaveRecordedRoute_Response_TypeSupportInterface_out;


            class Sample_SaveRecordedRoute_Response_DataWriter;

            typedef Sample_SaveRecordedRoute_Response_DataWriter * Sample_SaveRecordedRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Response_DataWriter> Sample_SaveRecordedRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Response_DataWriter> Sample_SaveRecordedRoute_Response_DataWriter_out;


            class Sample_SaveRecordedRoute_Response_DataReader;

            typedef Sample_SaveRecordedRoute_Response_DataReader * Sample_SaveRecordedRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Response_DataReader> Sample_SaveRecordedRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Response_DataReader> Sample_SaveRecordedRoute_Response_DataReader_out;


            class Sample_SaveRecordedRoute_Response_DataReaderView;

            typedef Sample_SaveRecordedRoute_Response_DataReaderView * Sample_SaveRecordedRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SaveRecordedRoute_Response_DataReaderView> Sample_SaveRecordedRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SaveRecordedRoute_Response_DataReaderView> Sample_SaveRecordedRoute_Response_DataReaderView_out;

            struct Sample_SaveRecordedRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SaveRecordedRoute_Response_, struct Sample_SaveRecordedRoute_Response_Seq_uniq_> Sample_SaveRecordedRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SaveRecordedRoute_Response_Seq> Sample_SaveRecordedRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SaveRecordedRoute_Response_Seq> Sample_SaveRecordedRoute_Response_Seq_out;

            class  Sample_SaveRecordedRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Response_TypeSupportInterface_var _var_type;

                static Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr _duplicate (Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SaveRecordedRoute_Response_TypeSupportInterface () {};
                ~Sample_SaveRecordedRoute_Response_TypeSupportInterface () {};
            private:
                Sample_SaveRecordedRoute_Response_TypeSupportInterface (const Sample_SaveRecordedRoute_Response_TypeSupportInterface &);
                Sample_SaveRecordedRoute_Response_TypeSupportInterface & operator = (const Sample_SaveRecordedRoute_Response_TypeSupportInterface &);
            };

            class  Sample_SaveRecordedRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SaveRecordedRoute_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Response_DataWriter_var _var_type;

                static Sample_SaveRecordedRoute_Response_DataWriter_ptr _duplicate (Sample_SaveRecordedRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SaveRecordedRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SaveRecordedRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SaveRecordedRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SaveRecordedRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SaveRecordedRoute_Response_& instance_data) = 0;

            protected:
                Sample_SaveRecordedRoute_Response_DataWriter () {};
                ~Sample_SaveRecordedRoute_Response_DataWriter () {};
            private:
                Sample_SaveRecordedRoute_Response_DataWriter (const Sample_SaveRecordedRoute_Response_DataWriter &);
                Sample_SaveRecordedRoute_Response_DataWriter & operator = (const Sample_SaveRecordedRoute_Response_DataWriter &);
            };

            class  Sample_SaveRecordedRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SaveRecordedRoute_Response_DataReader_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Response_DataReader_var _var_type;

                static Sample_SaveRecordedRoute_Response_DataReader_ptr _duplicate (Sample_SaveRecordedRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SaveRecordedRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SaveRecordedRoute_Response_& instance) = 0;

            protected:
                Sample_SaveRecordedRoute_Response_DataReader () {};
                ~Sample_SaveRecordedRoute_Response_DataReader () {};
            private:
                Sample_SaveRecordedRoute_Response_DataReader (const Sample_SaveRecordedRoute_Response_DataReader &);
                Sample_SaveRecordedRoute_Response_DataReader & operator = (const Sample_SaveRecordedRoute_Response_DataReader &);
            };

            class  Sample_SaveRecordedRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SaveRecordedRoute_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SaveRecordedRoute_Response_DataReaderView_var _var_type;

                static Sample_SaveRecordedRoute_Response_DataReaderView_ptr _duplicate (Sample_SaveRecordedRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SaveRecordedRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SaveRecordedRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SaveRecordedRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SaveRecordedRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SaveRecordedRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SaveRecordedRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SaveRecordedRoute_Response_& instance) = 0;

            protected:
                Sample_SaveRecordedRoute_Response_DataReaderView () {};
                ~Sample_SaveRecordedRoute_Response_DataReaderView () {};
            private:
                Sample_SaveRecordedRoute_Response_DataReaderView (const Sample_SaveRecordedRoute_Response_DataReaderView &);
                Sample_SaveRecordedRoute_Response_DataReaderView & operator = (const Sample_SaveRecordedRoute_Response_DataReaderView &);
            };
        }

    }

}

#endif
