#ifndef _H_5C0199FA9915ACF852BF52C6F1CDA3CD_SaveRoute__H_
#define _H_5C0199FA9915ACF852BF52C6F1CDA3CD_SaveRoute__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "marti_nav_msgs/msg/dds_opensplice/Route_.h"


namespace marti_nav_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SaveRoute_Request_
            {
                ::DDS::String_mgr name_;
                ::DDS::String_mgr guid_;
                ::marti_nav_msgs::msg::dds_::Route_ route_;
                ::DDS::String_mgr thumbnail_;
            };

            typedef DDS_DCPSStruct_var<SaveRoute_Request_> SaveRoute_Request__var;
            typedef DDS_DCPSStruct_out < SaveRoute_Request_> SaveRoute_Request__out;

            struct  SaveRoute_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<SaveRoute_Response_> SaveRoute_Response__var;
            typedef DDS_DCPSStruct_out < SaveRoute_Response_> SaveRoute_Response__out;

            struct  Sample_SaveRoute_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::marti_nav_msgs::srv::dds_::SaveRoute_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SaveRoute_Request_> Sample_SaveRoute_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SaveRoute_Request_> Sample_SaveRoute_Request__out;

            struct  Sample_SaveRoute_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::marti_nav_msgs::srv::dds_::SaveRoute_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SaveRoute_Response_> Sample_SaveRoute_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SaveRoute_Response_> Sample_SaveRoute_Response__out;

        }

    }

}

#endif /* _H_5C0199FA9915ACF852BF52C6F1CDA3CD_SaveRoute__H_ */
