#ifndef _H_88CE09262DEBD698DAD240195D818B8D_SetRoute_DCPS_H_
#define _H_88CE09262DEBD698DAD240195D818B8D_SetRoute_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetRoute_.h"


namespace marti_nav_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetRoute_Request_TypeSupportInterface;

            typedef SetRoute_Request_TypeSupportInterface * SetRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Request_TypeSupportInterface> SetRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetRoute_Request_TypeSupportInterface> SetRoute_Request_TypeSupportInterface_out;


            class SetRoute_Request_DataWriter;

            typedef SetRoute_Request_DataWriter * SetRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Request_DataWriter> SetRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetRoute_Request_DataWriter> SetRoute_Request_DataWriter_out;


            class SetRoute_Request_DataReader;

            typedef SetRoute_Request_DataReader * SetRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Request_DataReader> SetRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetRoute_Request_DataReader> SetRoute_Request_DataReader_out;


            class SetRoute_Request_DataReaderView;

            typedef SetRoute_Request_DataReaderView * SetRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Request_DataReaderView> SetRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetRoute_Request_DataReaderView> SetRoute_Request_DataReaderView_out;

            struct SetRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetRoute_Request_, struct SetRoute_Request_Seq_uniq_> SetRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < SetRoute_Request_Seq> SetRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetRoute_Request_Seq> SetRoute_Request_Seq_out;

            class  SetRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetRoute_Request_TypeSupportInterface_var _var_type;

                static SetRoute_Request_TypeSupportInterface_ptr _duplicate (SetRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetRoute_Request_TypeSupportInterface () {};
                ~SetRoute_Request_TypeSupportInterface () {};
            private:
                SetRoute_Request_TypeSupportInterface (const SetRoute_Request_TypeSupportInterface &);
                SetRoute_Request_TypeSupportInterface & operator = (const SetRoute_Request_TypeSupportInterface &);
            };

            class  SetRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetRoute_Request_DataWriter_ptr _ptr_type;
                typedef SetRoute_Request_DataWriter_var _var_type;

                static SetRoute_Request_DataWriter_ptr _duplicate (SetRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRoute_Request_& instance_data) = 0;

            protected:
                SetRoute_Request_DataWriter () {};
                ~SetRoute_Request_DataWriter () {};
            private:
                SetRoute_Request_DataWriter (const SetRoute_Request_DataWriter &);
                SetRoute_Request_DataWriter & operator = (const SetRoute_Request_DataWriter &);
            };

            class  SetRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetRoute_Request_DataReader_ptr _ptr_type;
                typedef SetRoute_Request_DataReader_var _var_type;

                static SetRoute_Request_DataReader_ptr _duplicate (SetRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRoute_Request_& instance) = 0;

            protected:
                SetRoute_Request_DataReader () {};
                ~SetRoute_Request_DataReader () {};
            private:
                SetRoute_Request_DataReader (const SetRoute_Request_DataReader &);
                SetRoute_Request_DataReader & operator = (const SetRoute_Request_DataReader &);
            };

            class  SetRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetRoute_Request_DataReaderView_ptr _ptr_type;
                typedef SetRoute_Request_DataReaderView_var _var_type;

                static SetRoute_Request_DataReaderView_ptr _duplicate (SetRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRoute_Request_& instance) = 0;

            protected:
                SetRoute_Request_DataReaderView () {};
                ~SetRoute_Request_DataReaderView () {};
            private:
                SetRoute_Request_DataReaderView (const SetRoute_Request_DataReaderView &);
                SetRoute_Request_DataReaderView & operator = (const SetRoute_Request_DataReaderView &);
            };
            class SetRoute_Response_TypeSupportInterface;

            typedef SetRoute_Response_TypeSupportInterface * SetRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Response_TypeSupportInterface> SetRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetRoute_Response_TypeSupportInterface> SetRoute_Response_TypeSupportInterface_out;


            class SetRoute_Response_DataWriter;

            typedef SetRoute_Response_DataWriter * SetRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Response_DataWriter> SetRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetRoute_Response_DataWriter> SetRoute_Response_DataWriter_out;


            class SetRoute_Response_DataReader;

            typedef SetRoute_Response_DataReader * SetRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Response_DataReader> SetRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetRoute_Response_DataReader> SetRoute_Response_DataReader_out;


            class SetRoute_Response_DataReaderView;

            typedef SetRoute_Response_DataReaderView * SetRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetRoute_Response_DataReaderView> SetRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetRoute_Response_DataReaderView> SetRoute_Response_DataReaderView_out;

            struct SetRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetRoute_Response_, struct SetRoute_Response_Seq_uniq_> SetRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < SetRoute_Response_Seq> SetRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetRoute_Response_Seq> SetRoute_Response_Seq_out;

            class  SetRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetRoute_Response_TypeSupportInterface_var _var_type;

                static SetRoute_Response_TypeSupportInterface_ptr _duplicate (SetRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetRoute_Response_TypeSupportInterface () {};
                ~SetRoute_Response_TypeSupportInterface () {};
            private:
                SetRoute_Response_TypeSupportInterface (const SetRoute_Response_TypeSupportInterface &);
                SetRoute_Response_TypeSupportInterface & operator = (const SetRoute_Response_TypeSupportInterface &);
            };

            class  SetRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetRoute_Response_DataWriter_ptr _ptr_type;
                typedef SetRoute_Response_DataWriter_var _var_type;

                static SetRoute_Response_DataWriter_ptr _duplicate (SetRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRoute_Response_& instance_data) = 0;

            protected:
                SetRoute_Response_DataWriter () {};
                ~SetRoute_Response_DataWriter () {};
            private:
                SetRoute_Response_DataWriter (const SetRoute_Response_DataWriter &);
                SetRoute_Response_DataWriter & operator = (const SetRoute_Response_DataWriter &);
            };

            class  SetRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetRoute_Response_DataReader_ptr _ptr_type;
                typedef SetRoute_Response_DataReader_var _var_type;

                static SetRoute_Response_DataReader_ptr _duplicate (SetRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRoute_Response_& instance) = 0;

            protected:
                SetRoute_Response_DataReader () {};
                ~SetRoute_Response_DataReader () {};
            private:
                SetRoute_Response_DataReader (const SetRoute_Response_DataReader &);
                SetRoute_Response_DataReader & operator = (const SetRoute_Response_DataReader &);
            };

            class  SetRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetRoute_Response_DataReaderView_ptr _ptr_type;
                typedef SetRoute_Response_DataReaderView_var _var_type;

                static SetRoute_Response_DataReaderView_ptr _duplicate (SetRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRoute_Response_& instance) = 0;

            protected:
                SetRoute_Response_DataReaderView () {};
                ~SetRoute_Response_DataReaderView () {};
            private:
                SetRoute_Response_DataReaderView (const SetRoute_Response_DataReaderView &);
                SetRoute_Response_DataReaderView & operator = (const SetRoute_Response_DataReaderView &);
            };
            class Sample_SetRoute_Request_TypeSupportInterface;

            typedef Sample_SetRoute_Request_TypeSupportInterface * Sample_SetRoute_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Request_TypeSupportInterface> Sample_SetRoute_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Request_TypeSupportInterface> Sample_SetRoute_Request_TypeSupportInterface_out;


            class Sample_SetRoute_Request_DataWriter;

            typedef Sample_SetRoute_Request_DataWriter * Sample_SetRoute_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Request_DataWriter> Sample_SetRoute_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Request_DataWriter> Sample_SetRoute_Request_DataWriter_out;


            class Sample_SetRoute_Request_DataReader;

            typedef Sample_SetRoute_Request_DataReader * Sample_SetRoute_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Request_DataReader> Sample_SetRoute_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Request_DataReader> Sample_SetRoute_Request_DataReader_out;


            class Sample_SetRoute_Request_DataReaderView;

            typedef Sample_SetRoute_Request_DataReaderView * Sample_SetRoute_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Request_DataReaderView> Sample_SetRoute_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Request_DataReaderView> Sample_SetRoute_Request_DataReaderView_out;

            struct Sample_SetRoute_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetRoute_Request_, struct Sample_SetRoute_Request_Seq_uniq_> Sample_SetRoute_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetRoute_Request_Seq> Sample_SetRoute_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetRoute_Request_Seq> Sample_SetRoute_Request_Seq_out;

            class  Sample_SetRoute_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetRoute_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetRoute_Request_TypeSupportInterface_var _var_type;

                static Sample_SetRoute_Request_TypeSupportInterface_ptr _duplicate (Sample_SetRoute_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetRoute_Request_TypeSupportInterface () {};
                ~Sample_SetRoute_Request_TypeSupportInterface () {};
            private:
                Sample_SetRoute_Request_TypeSupportInterface (const Sample_SetRoute_Request_TypeSupportInterface &);
                Sample_SetRoute_Request_TypeSupportInterface & operator = (const Sample_SetRoute_Request_TypeSupportInterface &);
            };

            class  Sample_SetRoute_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetRoute_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SetRoute_Request_DataWriter_var _var_type;

                static Sample_SetRoute_Request_DataWriter_ptr _duplicate (Sample_SetRoute_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetRoute_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetRoute_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetRoute_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRoute_Request_& instance_data) = 0;

            protected:
                Sample_SetRoute_Request_DataWriter () {};
                ~Sample_SetRoute_Request_DataWriter () {};
            private:
                Sample_SetRoute_Request_DataWriter (const Sample_SetRoute_Request_DataWriter &);
                Sample_SetRoute_Request_DataWriter & operator = (const Sample_SetRoute_Request_DataWriter &);
            };

            class  Sample_SetRoute_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetRoute_Request_DataReader_ptr _ptr_type;
                typedef Sample_SetRoute_Request_DataReader_var _var_type;

                static Sample_SetRoute_Request_DataReader_ptr _duplicate (Sample_SetRoute_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRoute_Request_& instance) = 0;

            protected:
                Sample_SetRoute_Request_DataReader () {};
                ~Sample_SetRoute_Request_DataReader () {};
            private:
                Sample_SetRoute_Request_DataReader (const Sample_SetRoute_Request_DataReader &);
                Sample_SetRoute_Request_DataReader & operator = (const Sample_SetRoute_Request_DataReader &);
            };

            class  Sample_SetRoute_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetRoute_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SetRoute_Request_DataReaderView_var _var_type;

                static Sample_SetRoute_Request_DataReaderView_ptr _duplicate (Sample_SetRoute_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRoute_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRoute_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRoute_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRoute_Request_& instance) = 0;

            protected:
                Sample_SetRoute_Request_DataReaderView () {};
                ~Sample_SetRoute_Request_DataReaderView () {};
            private:
                Sample_SetRoute_Request_DataReaderView (const Sample_SetRoute_Request_DataReaderView &);
                Sample_SetRoute_Request_DataReaderView & operator = (const Sample_SetRoute_Request_DataReaderView &);
            };
            class Sample_SetRoute_Response_TypeSupportInterface;

            typedef Sample_SetRoute_Response_TypeSupportInterface * Sample_SetRoute_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Response_TypeSupportInterface> Sample_SetRoute_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Response_TypeSupportInterface> Sample_SetRoute_Response_TypeSupportInterface_out;


            class Sample_SetRoute_Response_DataWriter;

            typedef Sample_SetRoute_Response_DataWriter * Sample_SetRoute_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Response_DataWriter> Sample_SetRoute_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Response_DataWriter> Sample_SetRoute_Response_DataWriter_out;


            class Sample_SetRoute_Response_DataReader;

            typedef Sample_SetRoute_Response_DataReader * Sample_SetRoute_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Response_DataReader> Sample_SetRoute_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Response_DataReader> Sample_SetRoute_Response_DataReader_out;


            class Sample_SetRoute_Response_DataReaderView;

            typedef Sample_SetRoute_Response_DataReaderView * Sample_SetRoute_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRoute_Response_DataReaderView> Sample_SetRoute_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetRoute_Response_DataReaderView> Sample_SetRoute_Response_DataReaderView_out;

            struct Sample_SetRoute_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetRoute_Response_, struct Sample_SetRoute_Response_Seq_uniq_> Sample_SetRoute_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetRoute_Response_Seq> Sample_SetRoute_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetRoute_Response_Seq> Sample_SetRoute_Response_Seq_out;

            class  Sample_SetRoute_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetRoute_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetRoute_Response_TypeSupportInterface_var _var_type;

                static Sample_SetRoute_Response_TypeSupportInterface_ptr _duplicate (Sample_SetRoute_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetRoute_Response_TypeSupportInterface () {};
                ~Sample_SetRoute_Response_TypeSupportInterface () {};
            private:
                Sample_SetRoute_Response_TypeSupportInterface (const Sample_SetRoute_Response_TypeSupportInterface &);
                Sample_SetRoute_Response_TypeSupportInterface & operator = (const Sample_SetRoute_Response_TypeSupportInterface &);
            };

            class  Sample_SetRoute_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetRoute_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SetRoute_Response_DataWriter_var _var_type;

                static Sample_SetRoute_Response_DataWriter_ptr _duplicate (Sample_SetRoute_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetRoute_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetRoute_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetRoute_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRoute_Response_& instance_data) = 0;

            protected:
                Sample_SetRoute_Response_DataWriter () {};
                ~Sample_SetRoute_Response_DataWriter () {};
            private:
                Sample_SetRoute_Response_DataWriter (const Sample_SetRoute_Response_DataWriter &);
                Sample_SetRoute_Response_DataWriter & operator = (const Sample_SetRoute_Response_DataWriter &);
            };

            class  Sample_SetRoute_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetRoute_Response_DataReader_ptr _ptr_type;
                typedef Sample_SetRoute_Response_DataReader_var _var_type;

                static Sample_SetRoute_Response_DataReader_ptr _duplicate (Sample_SetRoute_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRoute_Response_& instance) = 0;

            protected:
                Sample_SetRoute_Response_DataReader () {};
                ~Sample_SetRoute_Response_DataReader () {};
            private:
                Sample_SetRoute_Response_DataReader (const Sample_SetRoute_Response_DataReader &);
                Sample_SetRoute_Response_DataReader & operator = (const Sample_SetRoute_Response_DataReader &);
            };

            class  Sample_SetRoute_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetRoute_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SetRoute_Response_DataReaderView_var _var_type;

                static Sample_SetRoute_Response_DataReaderView_ptr _duplicate (Sample_SetRoute_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRoute_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRoute_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRoute_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRoute_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRoute_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRoute_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRoute_Response_& instance) = 0;

            protected:
                Sample_SetRoute_Response_DataReaderView () {};
                ~Sample_SetRoute_Response_DataReaderView () {};
            private:
                Sample_SetRoute_Response_DataReaderView (const Sample_SetRoute_Response_DataReaderView &);
                Sample_SetRoute_Response_DataReaderView & operator = (const Sample_SetRoute_Response_DataReaderView &);
            };
        }

    }

}

#endif
